/* ####################################### JSON START ####################################### */

const jsonContent = {
    "SEQUENCE": {
        "CSPAdminCommand": {
            "id": "CSPAdminCommand",
            "caption": "ASN 7-1ba: CSP Protocol: ASN.1 Definition for the CSPAdminCommand",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "7..n",
                    "type_outer": null,
                    "type_inner": "CSPAdminCommand",
                    "Description": "'CSPAdminCommand': Administrative operations to manage a CSP Application through its SD.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "5..n",
                    "type_outer": null,
                    "type_inner": "CSPAdminCommandChoice",
                    "Description": "'adminCommandChoice': ",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": []
        },
        "CSPEnforce": {
            "id": "CSPEnforce",
            "caption": "ASN 7-2: Admin: ASN.1 Definition for CSPEnforce",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3..n",
                    "type_outer": null,
                    "type_inner": "CSPEnforce",
                    "Description": "'CSPEnforce': Command that checks features and algorithms on the platform.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPCoreSupport",
                    "Description": "'coreSupport': Optional core functionality (e.g., policies).",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPCipherSupport",
                    "Description": "'cipherSupport': Cipher and padding algorithms.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPSignatureSupport",
                    "Description": "'signatureSupport': Signature algorithms.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "84",
                    "Length": "0",
                    "type_outer": null,
                    "type_inner": "NULL",
                    "Description": "'transformSupport': Cipher encryption transformation.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A5",
                    "Length": "0..8",
                    "type_outer": null,
                    "type_inner": "CSPSecureChannelSupport",
                    "Description": "'secChannelSupport': Secure channel protocols.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "86",
                    "Length": "0",
                    "type_outer": null,
                    "type_inner": "NULL",
                    "Description": "'confidentialSupport': Confidential data transfer extension of the secure channel service.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A7",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPAttestationSupport",
                    "Description": "'attestationSupport': Attestation types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A8",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPKeySupport",
                    "Description": "'keySupport': Key type, size, curve, along with derivation and agreement algorithms.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A9",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPCertificateSupport",
                    "Description": "'certificateSupport': Certificate types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "AA",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPPasswordSupport",
                    "Description": "'passwordSupport': Password management operations.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "AB",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPCounterSupport",
                    "Description": "'counterSupport': Counter types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "AC",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPTimeSupport",
                    "Description": "'timeSupport': Time management and timer types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "AD",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPAuditSupport",
                    "Description": "'auditSupport': Secure auditing and event types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "8E",
                    "Length": "0",
                    "type_outer": null,
                    "type_inner": "NULL",
                    "Description": "'offloadingSupport': Resource import and export functionality.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "AF",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPFieldSupport",
                    "Description": "'fieldSupport': Fields to be included in attestation results and log messages.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "B0",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPPolicySupport",
                    "Description": "'policySupport': Constraint-based access control using policies.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice"
            ]
        },
        "CSPRegisterClient": {
            "id": "CSPRegisterClient",
            "caption": "ASN 7-3: Admin: ASN.1 Definition for CSPRegisterClient",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "7..n",
                    "type_outer": null,
                    "type_inner": "CSPRegisterClient",
                    "Description": "'CSPRegisterClient': Command to register a Client Application or an off-card Client to the CSP.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "2..n",
                    "type_outer": null,
                    "type_inner": "CSPClient",
                    "Description": "'client': The Client Application or off-card Client to register.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice"
            ]
        },
        "CSPUnregisterClient": {
            "id": "CSPUnregisterClient",
            "caption": "ASN 7-4: Admin: ASN.1 Definition for CSPUnregisterClient",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..21",
                    "type_outer": null,
                    "type_inner": "CSPUnregisterClient",
                    "Description": "'CSPUnregisterClient': Command to unregister a CSP Client, revoking its access to the CSP.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "1..16",
                    "type_outer": null,
                    "type_inner": "CSPClientReference",
                    "Description": "'client': The client identifier or the AID of a Client Application.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice"
            ]
        },
        "CSPCreateResource": {
            "id": "CSPCreateResource",
            "caption": "ASN 7-5: Admin: ASN.1 Definition for CSPCreateResource",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "17..338",
                    "type_outer": null,
                    "type_inner": "CSPCreateResource",
                    "Description": "'CSPCreateResource': Command to create a key, certificate or password resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "12..331",
                    "type_outer": null,
                    "type_inner": "CSPResource",
                    "Description": "'resouceData': The resource data (e.g., resource ID, resource type, etc.).",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice"
            ]
        },
        "CSPDestroyResource": {
            "id": "CSPDestroyResource",
            "caption": "ASN 7-6: Admin: ASN.1 Definition for CSPDestroyResource",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..7",
                    "type_outer": null,
                    "type_inner": "CSPDestroyResource",
                    "Description": "'CSPDestroyResource': Command to remove a key or password resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'resourceId': The resource ID that shall be unregistered.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice"
            ]
        },
        "CSPConfigureResource": {
            "id": "CSPConfigureResource",
            "caption": "ASN 7-7: Admin: ASN.1 Definition for CSPConfigureResource",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..311",
                    "type_outer": null,
                    "type_inner": "CSPConfigureResource",
                    "Description": "'CSPConfigureResource': Command to configure a resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'resourceId': The resource to be modified.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "0..45",
                    "type_outer": null,
                    "type_inner": "CSPAccessControl",
                    "Description": "'accessControl': The access control configuration for the resource.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "0..37",
                    "type_outer": null,
                    "type_inner": "CSPAlgorithms",
                    "Description": "'algorithms': The algorithm configuration of the resource.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A4",
                    "Length": "0..80",
                    "type_outer": null,
                    "type_inner": "CSPCounters",
                    "Description": "'counters': Usage counter or authentication counter configurations of the resource.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A5",
                    "Length": "0..32",
                    "type_outer": null,
                    "type_inner": "CSPTimers",
                    "Description": "'timers': Validity date, validity period or timeout configurations.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A6",
                    "Length": "0..100",
                    "type_outer": "SET OF",
                    "type_inner": "CSPResourceEvent",
                    "Description": "'resourceEvents': The events that shall be logged for this resource.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice"
            ]
        },
        "CSPSetup": {
            "id": "CSPSetup",
            "caption": "ASN 7-8: Admin: ASN.1 Definition for CSPSetup",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3..n",
                    "type_outer": null,
                    "type_inner": "CSPSetup",
                    "Description": "'CSPSetup': Command to setup general settings of the CSP Instance.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..47",
                    "type_outer": null,
                    "type_inner": "CSPSettings",
                    "Description": "'cspSettings': Version, name, attestation key and error handling of this CSP Instance.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "0..13",
                    "type_outer": null,
                    "type_inner": "CSPSecureChannelSettings",
                    "Description": "'secureChannelSettings': Set the general secure channel authentication timeout.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "0..5",
                    "type_outer": null,
                    "type_inner": "CSPPolicySettings",
                    "Description": "'policySettings': Select policy mode for handling unavailable policy types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A4",
                    "Length": "0..5",
                    "type_outer": null,
                    "type_inner": "CSPCounterSettings",
                    "Description": "'counterSettings': Select counter mode for handling unavailable counter types and sizes.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A5",
                    "Length": "0..12",
                    "type_outer": null,
                    "type_inner": "CSPTimeSettings",
                    "Description": "'timeSettings': Configure time management and handling of unavailable time.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A6",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPAuditSettings",
                    "Description": "'auditSettings': Configure audit event logging and handling of unavailable event types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A7",
                    "Length": "0..5",
                    "type_outer": null,
                    "type_inner": "CSPFieldSettings",
                    "Description": "'fieldSettings': Select field mode for handling unavailable signature fields.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice"
            ]
        },
        "CSPActivate": {
            "id": "CSPActivate",
            "caption": "ASN 7-9: Admin: ASN.1 Definition for CSPActivate",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3..7",
                    "type_outer": null,
                    "type_inner": "CSPActivate",
                    "Description": "'CSPActivate': Command to finalize a CSP Configuration.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..2",
                    "type_outer": null,
                    "type_inner": "CSPConfigVersion",
                    "Description": "'configVersion': Custom version of the CSP Configuration chosen by the CSP Admin.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice"
            ]
        },
        "CSPDeactivate": {
            "id": "CSPDeactivate",
            "caption": "ASN 7-10: Admin: ASN.1 Definition for CSPDeactivate",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3",
                    "type_outer": null,
                    "type_inner": "CSPDeactivate",
                    "Description": "'CSPDeactivate': Command to deactivate a CSP Configuration.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice"
            ]
        },
        "CSPGetConfiguration": {
            "id": "CSPGetConfiguration",
            "caption": "ASN 7-11: Admin: ASN.1 Definition for CSPGetConfiguration",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3",
                    "type_outer": null,
                    "type_inner": "CSPGetConfiguration",
                    "Description": "'CSPGetConfiguration': Command to retrieve the entire CSP Configuration.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice",
                "CSPRequiresAuthentication"
            ]
        },
        "CSPGetConfigurationResponse": {
            "id": "CSPGetConfigurationResponse",
            "caption": "ASN 7-12: Admin: ASN.1 Definition for CSPGetConfigurationResponse",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "84..n",
                    "type_outer": null,
                    "type_inner": "CSPGetConfigurationResponse",
                    "Description": "'CSPGetConfigurationResponse': Response of the CSPGetConfiguration command.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Version of the CSP Admin Protocol used.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "79..n",
                    "type_outer": null,
                    "type_inner": "CSPConfiguration",
                    "Description": "'cspConfiguration': CSP Configuration of the entire CSP Instance.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": []
        },
        "CSPSetValue": {
            "id": "CSPSetValue",
            "caption": "ASN 7-13: Resource: ASN.1 Definition for CSPSetValue",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "11..65573",
                    "type_outer": null,
                    "type_inner": "CSPSetValue",
                    "Description": "'CSPSetValue': Command to set the value of a key, certificate or pwd resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'resourceId': The identifier of the resource to set the value for.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'decryptionResourceId': If set, the data is decrypted before being assigned to the resource.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "0..65536",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'data': The value of the resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "84",
                    "Length": "0..16",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'initializationData': Algorithm-specific initialization data for decryption, e.g., iv data.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "85",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "BOOLEAN",
                    "Description": "'inTransport': Is this an initial value requiring change (only for passwords)?",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice"
            ]
        },
        "CSPClientCommand": {
            "id": "CSPClientCommand",
            "caption": "ASN 7-14a: CSP Protocol: ASN.1 Definition for the CSPClientCommand",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "7..98329",
                    "type_outer": null,
                    "type_inner": "CSPClientCommand",
                    "Description": "'CSPClientCommand': Client operations to use the cryptographic services of the CSP.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "5..98324",
                    "type_outer": null,
                    "type_inner": "CSPClientCommandChoice",
                    "Description": "'clientCommandChoice': ",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": []
        },
        "CSPProcessSecurity": {
            "id": "CSPProcessSecurity",
            "caption": "ASN 7-15: Secure Channel: ASN.1 Definition for CSPProcessSecurity",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..32774",
                    "type_outer": null,
                    "type_inner": "CSPProcessSecurity",
                    "Description": "'CSPProcessSecurity': Command to process security for secure channel authentication.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..32767",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'apduData': APDU data for processing security.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPClientCommandChoice"
            ]
        },
        "CSPProcessSecurityResponse": {
            "id": "CSPProcessSecurityResponse",
            "caption": "ASN 7-16: Attestations: ASN.1 Definition for CSPProcessSecurityResponse",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3..32771",
                    "type_outer": null,
                    "type_inner": "CSPProcessSecurityResponse",
                    "Description": "'CSPProcessSecurityResponse': Response of the CSPProcessSecurity command.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1..32767",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'outputData': Output APDU resulting from secure channel processing.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": []
        },
        "CSPSign": {
            "id": "CSPSign",
            "caption": "ASN 7-17: Signature: ASN.1 Definition for CSPSign",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "8..32778",
                    "type_outer": null,
                    "type_inner": "CSPSign",
                    "Description": "'CSPSign': Command for data signing.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'signingResourceId': The resource ID used to compute the signature.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..32767",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'inputData': The data to sign.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPRequiresAuthentication"
            ]
        },
        "CSPSignResponse": {
            "id": "CSPSignResponse",
            "caption": "ASN 7-18: Attestations: ASN.1 Definition for CSPSignResponse",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "66..65541",
                    "type_outer": null,
                    "type_inner": "CSPSignResponse",
                    "Description": "'CSPSignResponse': Response of the CSPSign command: The signature computed by the CSP.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "64..65536",
                    "type_outer": null,
                    "type_inner": "CSPSignature",
                    "Description": "'signature': ",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": []
        },
        "CSPVerifySignature": {
            "id": "CSPVerifySignature",
            "caption": "ASN 7-19: Signature: ASN.1 Definition for CSPVerifySignature",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "74..98319",
                    "type_outer": null,
                    "type_inner": "CSPVerifySignature",
                    "Description": "'CSPVerifySignature': Command to verify a signature.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'signingResourceId': The resource ID used to compute the signature.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..32767",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'data': The signed data.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "64..65536",
                    "type_outer": null,
                    "type_inner": "CSPSignature",
                    "Description": "'signature': The signature to verify.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPRequiresAuthentication"
            ]
        },
        "CSPVerifySignatureResponse": {
            "id": "CSPVerifySignatureResponse",
            "caption": "ASN 7-20: Attestations: ASN.1 Definition for CSPVerifySignatureResponse",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "4",
                    "type_outer": null,
                    "type_inner": "CSPVerifySignatureResponse",
                    "Description": "'CSPVerifySignatureResponse': Response of the CSPVerifySignature command.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "2",
                    "type_outer": null,
                    "type_inner": "CSPBoolean",
                    "Description": "'response': ",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": []
        },
        "CSPEncrypt": {
            "id": "CSPEncrypt",
            "caption": "ASN 7-21: Cipher: ASN.1 Definition for CSPEncrypt",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "8..32796",
                    "type_outer": null,
                    "type_inner": "CSPEncrypt",
                    "Description": "'CSPEncrypt': Command to encrypt data.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'keyResourceId': The resource ID used to encrypt the data.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..16",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'initializationData': Algorithm-specific initialization data for encryption, e.g., IV data.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "0..32767",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'inputData': The data to encrypt.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPRequiresAuthentication"
            ]
        },
        "CSPDecrypt": {
            "id": "CSPDecrypt",
            "caption": "ASN 7-23: Cipher: ASN.1 Definition for CSPDecrypt",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "8..32796",
                    "type_outer": null,
                    "type_inner": "CSPDecrypt",
                    "Description": "'CSPDecrypt': Command to decrypt data.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'keyResourceId': The resource ID used to decrypt the data.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..16",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'initializationData': Algorithm-specific initialization data for decryption, e.g., IV data.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "0..32767",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'inputData': The data to decrypt.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPRequiresAuthentication"
            ]
        },
        "CSPResourceAttestation": {
            "id": "CSPResourceAttestation",
            "caption": "ASN 7-25: Attestations: ASN.1 Definition for CSPResourceAttestation",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "27..526",
                    "type_outer": null,
                    "type_inner": "CSPResourceAttestation",
                    "Description": "'CSPResourceAttestation': Command to compute resource attestations.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPResourceAttestationType",
                    "Description": "'attestationType': The attestation type used.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'attestationResourceId': The resource ID used to create the attestation signature.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "16..512",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'inputData': Additional input data to be included in the attestation.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPRequiresAuthentication"
            ]
        },
        "CSPClearResource": {
            "id": "CSPClearResource",
            "caption": "ASN 7-27: Resource: ASN.1 Definition for CSPClearResource",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..7",
                    "type_outer": null,
                    "type_inner": "CSPClearResource",
                    "Description": "'CSPClearResource': Command to remove the value of a key or password resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'resourceId': The identifier of the resource that shall be cleared.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice",
                "CSPRequiresAuthentication"
            ]
        },
        "CSPSystemAttestation": {
            "id": "CSPSystemAttestation",
            "caption": "ASN 7-28: Attestations: ASN.1 Definition for CSPSystemAttestation",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..522",
                    "type_outer": null,
                    "type_inner": "CSPSystemAttestation",
                    "Description": "'CSPSystemAttestation': Command to retrieve signed attestation data of the platform and the CSP.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPSystemAttestationType",
                    "Description": "'attestationType': CASD-based CSP platform or CSP-specific config attestation.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..512",
                    "type_outer": null,
                    "type_inner": "CSPChallenge",
                    "Description": "'challenge': Challenge for verification of attestation integrity.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice",
                "CSPClientCommandChoice"
            ]
        },
        "CSPGenerateKey": {
            "id": "CSPGenerateKey",
            "caption": "ASN 7-30: Key: ASN.1 Definition for CSPGenerateKey",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..7",
                    "type_outer": null,
                    "type_inner": "CSPGenerateKey",
                    "Description": "'CSPGenerateKey': Command for key generation.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'keyResourceId': The key for which the value should be generated.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice",
                "CSPRequiresAuthentication"
            ]
        },
        "CSPComputePublicKey": {
            "id": "CSPComputePublicKey",
            "caption": "ASN 7-31: Key: ASN.1 Definition for CSPComputePublicKey",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "9..11",
                    "type_outer": null,
                    "type_inner": "CSPComputePublicKey",
                    "Description": "'CSPComputePublicKey': Command to compute a public key from its private key.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'privateResourceId': The corresponding private key that is already initialized.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'publicResourceId': The public key that shall be computed.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice",
                "CSPRequiresAuthentication"
            ]
        },
        "CSPDeriveKey": {
            "id": "CSPDeriveKey",
            "caption": "ASN 7-32: Key: ASN.1 Definition for CSPDeriveKey",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "27..527",
                    "type_outer": null,
                    "type_inner": "CSPDeriveKey",
                    "Description": "'CSPDeriveKey': Command for key derivation.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'sourceResourceId': The resource that is base source for key derivation.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'destResourceId': The destination resource to store the derived key value.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "16..512",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'inputData': Additional input data given into the derivation algorithm",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice",
                "CSPRequiresAuthentication"
            ]
        },
        "CSPSetTime": {
            "id": "CSPSetTime",
            "caption": "ASN 7-33: Time: ASN.1 Definition for CSPSetTime",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "13..65554",
                    "type_outer": null,
                    "type_inner": "CSPSetTime",
                    "Description": "'CSPSetTime': Command to set a new reference time to the CSP Instance.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Minimum API level required for the CSP Protocol.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "8",
                    "type_outer": null,
                    "type_inner": "CSPTimestamp",
                    "Description": "'newTime': The new reference time.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..65536",
                    "type_outer": null,
                    "type_inner": "CSPSignature",
                    "Description": "'signature': Signature to verify the authenticity of the new reference time.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAdminCommandChoice",
                "CSPRequiresAuthentication"
            ]
        },
        "CSPSetTimeResponse": {
            "id": "CSPSetTimeResponse",
            "caption": "ASN 7-34: Attestations: ASN.1 Definition for CSPSetTimeResponse",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "4",
                    "type_outer": null,
                    "type_inner": "CSPSetTimeResponse",
                    "Description": "'CSPSetTimeResponse': Response of the CSPSetTime command: TRUE if time was successfully updated.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "2",
                    "type_outer": null,
                    "type_inner": "CSPBoolean",
                    "Description": "'response': ",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": []
        },
        "CSPCoreSupport": {
            "id": "CSPCoreSupport",
            "caption": "ASN 5-1: Access: ASN.1 Definition for CSPCoreSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..8",
                    "type_outer": null,
                    "type_inner": "CSPCoreSupport",
                    "Description": "'CSPCoreSupport': Supported core features.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..6",
                    "type_outer": "SET OF",
                    "type_inner": "CSPErrorMode",
                    "Description": "'errorModes': CSP error handling modes.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPSettings": {
            "id": "CSPSettings",
            "caption": "ASN 5-2: Core: ASN.1 Definition for CSPSettings",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "34..45",
                    "type_outer": null,
                    "type_inner": "CSPSettings",
                    "Description": "'CSPSettings': Structure representing general configuration settings of the CSP Instance.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "32",
                    "type_outer": null,
                    "type_inner": "CSPConfigName",
                    "Description": "'configName': Custom name of the CSP Configuration chosen by the CSP Admin.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..2",
                    "type_outer": null,
                    "type_inner": "CSPConfigVersion",
                    "Description": "'configVersion': Custom version of the CSP Configuration chosen by the CSP Admin.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'configAttestationKey': The key that shall be used to compute the config attestation.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPErrorMode",
                    "Description": "'errorMode': Specify how the CSP shall handle exceptions.",
                    "Presence": "OPTIONAL",
                    "Default": "ERROR_MODE_BASIC"
                }
            ],
            "used_in": [
                "CSPSetup",
                "CSPConfiguration"
            ]
        },
        "CSPConfiguration": {
            "id": "CSPConfiguration",
            "caption": "ASN 5-4: Core: ASN.1 Definition for CSPConfiguration",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "79..n",
                    "type_outer": null,
                    "type_inner": "CSPConfiguration",
                    "Description": "'CSPConfiguration': Structure containing the entire CSP Configuration.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPMode",
                    "Description": "'cspMode': Indicates whether this CSP configuration is currently activated.",
                    "Presence": "OPTIONAL",
                    "Default": "CSP_MODE_CONFIGURATION"
                },
                {
                    "Tag": "A1",
                    "Length": "0..47",
                    "type_outer": null,
                    "type_inner": "CSPSettings",
                    "Description": "'cspSettings': Name, version, attestation key and error handling of the CSP Instance.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "55..66",
                    "type_outer": null,
                    "type_inner": "CSPPlatform",
                    "Description": "'cspPlatform': Static (read-only) information about the CSP platform.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "4..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPClient",
                    "Description": "'clients': List of CSP Clients registered to this CSP Instance.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A4",
                    "Length": "14..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPResource",
                    "Description": "'resources': List of resources along with their cryptographic configurations.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A5",
                    "Length": "0..13",
                    "type_outer": null,
                    "type_inner": "CSPSecureChannelSettings",
                    "Description": "'secureChannelSettings': Set the general secure channel authentication timeout.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A6",
                    "Length": "0..5",
                    "type_outer": null,
                    "type_inner": "CSPPolicySettings",
                    "Description": "'policySettings': Select policy mode for handling unavailable policy types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A7",
                    "Length": "0..5",
                    "type_outer": null,
                    "type_inner": "CSPCounterSettings",
                    "Description": "'counterSettings': Select counter mode for handling unavailable counter types and sizes.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A8",
                    "Length": "0..12",
                    "type_outer": null,
                    "type_inner": "CSPTimeSettings",
                    "Description": "'timeSettings': Configure time management and handling of unavailable time.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A9",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPAuditSettings",
                    "Description": "'auditSettings': Configure audit event logging and handling of unavailable event types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "AA",
                    "Length": "0..5",
                    "type_outer": null,
                    "type_inner": "CSPFieldSettings",
                    "Description": "'fieldSettings': Select field mode for handling unavailable signature fields.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPGetConfigurationResponse"
            ]
        },
        "CSPPlatform": {
            "id": "CSPPlatform",
            "caption": "ASN 5-9: Core: ASN.1 Definition for CSPPlatform",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "53..64",
                    "type_outer": null,
                    "type_inner": "CSPPlatform",
                    "Description": "'CSPPlatform': General information about the CSP platform.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Version of the CSP Protocol (Version).",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "3",
                    "type_outer": null,
                    "type_inner": "CSPAPIVersion",
                    "Description": "'cspApiVersion': Version of the Java Card CSP API (Major, Minor, Patch).",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "2",
                    "type_outer": null,
                    "type_inner": "CSPELFVersion",
                    "Description": "'cspELFVersion': Version of the CSP ELF file (Major, Minor).",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "32",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'platformName': Name and version of the SE platform encoded in ASCII.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "84",
                    "Length": "5..16",
                    "type_outer": null,
                    "type_inner": "CSPAID",
                    "Description": "'cspInstanceAID': AID of the CSP Instance.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPConfiguration",
                "CSPSignedPlatformData",
                "CSPSignedConfigData"
            ]
        },
        "CSPResourceSupport": {
            "id": "CSPResourceSupport",
            "caption": "ASN 5-16: Resource: ASN.1 Definition for CSPResourceSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..17",
                    "type_outer": null,
                    "type_inner": "CSPResourceSupport",
                    "Description": "'CSPResourceSupport': Supported resource features.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..15",
                    "type_outer": "SET OF",
                    "type_inner": "CSPResourceType",
                    "Description": "'resourceTypes': Supported resource types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": []
        },
        "CSPResource": {
            "id": "CSPResource",
            "caption": "ASN 5-17a: Resource: ASN.1 Definition for CSPResource",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "10..327",
                    "type_outer": null,
                    "type_inner": "CSPResource",
                    "Description": "'CSPResource': Data structure representing a resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'resourceId': Unique identifier of the resource choosen by the CSP Admin.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "2..14",
                    "type_outer": null,
                    "type_inner": "CSPResourceParams",
                    "Description": "'resourceParams': The resource-specific parameters (e.g., key type, curve, min-size).",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPUsageType",
                    "Description": "'usageType': The usage type specifying the CSP operations sllowed for the resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "0..45",
                    "type_outer": null,
                    "type_inner": "CSPAccessControl",
                    "Description": "'accessControl': Access conrol configuration for the resource.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A4",
                    "Length": "0..37",
                    "type_outer": null,
                    "type_inner": "CSPAlgorithms",
                    "Description": "'algorithms': The algorithm configuration of the resource.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A5",
                    "Length": "0..80",
                    "type_outer": null,
                    "type_inner": "CSPCounters",
                    "Description": "'counters': ",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A6",
                    "Length": "0..32",
                    "type_outer": null,
                    "type_inner": "CSPTimers",
                    "Description": "'timers': ",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A7",
                    "Length": "0..100",
                    "type_outer": "SET OF",
                    "type_inner": "CSPResourceEvent",
                    "Description": "'resourceEvents': The events that shall be audited for this resource.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPCreateResource",
                "CSPConfiguration"
            ]
        },
        "CSPClient": {
            "id": "CSPClient",
            "caption": "ASN 5-24: Core: ASN.1 Definition for CSPClient",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPClient",
                    "Description": "'CSPClient': Data structure representing a Client Application or an off-card Client.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "0..2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "'clientId': An identifier of the CSP Client, chosen by the CSP Admin.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPClientApplication",
                    "Description": "'clientApplication': The Client Application registered to the CSP.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolType",
                    "Description": "'authProtocol': Restrict access to CSP services when a sec channel is fully established.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "0..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPResourceId",
                    "Description": "'authResources': Resources required for the configured authProtocol.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPRegisterClient",
                "CSPConfiguration"
            ]
        },
        "CSPClientApplication": {
            "id": "CSPClientApplication",
            "caption": "ASN 5-26a: Core: ASN.1 Definition for CSPClientApplication",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "10..n",
                    "type_outer": null,
                    "type_inner": "CSPClientApplication",
                    "Description": "'CSPClientApplication': Data structure representing a Client Application.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "5..16",
                    "type_outer": null,
                    "type_inner": "CSPAID",
                    "Description": "'applicationAID': AID of the Client Application.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'loadFileDataBlockHash': Hash of the load data file block of the Client Application.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "BOOLEAN",
                    "Description": "'requiredDAPVerification': Client Application must be DAP-verified during load.",
                    "Presence": "OPTIONAL",
                    "Default": "FALSE"
                },
                {
                    "Tag": "A3",
                    "Length": "1..16",
                    "type_outer": null,
                    "type_inner": "CSPApplicationSD",
                    "Description": "'applicationSD': AID of the SD of the Client Application.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPClient"
            ]
        },
        "CSPAccessControl": {
            "id": "CSPAccessControl",
            "caption": "ASN 5-27: Access: ASN.1 Definition for CSPAccessControl",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "CSPAccessControl",
                    "Description": "'CSPAccessControl': Data structure for access control configuration of a resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "0..2",
                    "type_outer": null,
                    "type_inner": "CSPAccessControlRules",
                    "Description": "'accessControlRules': ACR bitmask.",
                    "Presence": "OPTIONAL",
                    "Default": "ANY_USE"
                },
                {
                    "Tag": "A1",
                    "Length": "0..16",
                    "type_outer": null,
                    "type_inner": "CSPClientReference",
                    "Description": "'owner': CSP Client that owns this resource .",
                    "Presence": "OPTIONAL",
                    "Default": "null"
                },
                {
                    "Tag": "A2",
                    "Length": "0..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPPolicy",
                    "Description": "'policies': Dynamic policy rules.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPConfigureResource",
                "CSPResource"
            ]
        },
        "CSPCipherSupport": {
            "id": "CSPCipherSupport",
            "caption": "ASN 6-1: Cipher: ASN.1 Definition for CSPCipherSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..61",
                    "type_outer": null,
                    "type_inner": "CSPCipherSupport",
                    "Description": "'CSPCipherSupport': Checks for cipher functionality support and supported algorithms.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..36",
                    "type_outer": "SET OF",
                    "type_inner": "CSPPaddingAlgorithm",
                    "Description": "'paddingsAlgorithms': Padding algorithms.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..21",
                    "type_outer": "SET OF",
                    "type_inner": "CSPCipherAlgorithm",
                    "Description": "'cipherAlgorithms': Cipher algorithms.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPCipherAlgorithms": {
            "id": "CSPCipherAlgorithms",
            "caption": "ASN 6-2: Cipher: ASN.1 Definition for CSPCipherAlgorithms",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3..6",
                    "type_outer": null,
                    "type_inner": "CSPCipherAlgorithms",
                    "Description": "'CSPCipherAlgorithms': Cipher configuration for a specific resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPCipherAlgorithm",
                    "Description": "'cipherAlgorithm': The cipher algorithm.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPPaddingAlgorithm",
                    "Description": "'paddingAlgorithm': The padding algorithm.",
                    "Presence": "OPTIONAL",
                    "Default": "PAD_NULL"
                }
            ],
            "used_in": [
                "CSPAlgorithms"
            ]
        },
        "CSPSignatureSupport": {
            "id": "CSPSignatureSupport",
            "caption": "ASN 6-5: Signature: ASN.1 Definition for CSPSignatureSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..37",
                    "type_outer": null,
                    "type_inner": "CSPSignatureSupport",
                    "Description": "'CSPSignatureSupport': Checks for signature functionality support and supported algorithms.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..21",
                    "type_outer": "SET OF",
                    "type_inner": "CSPMessageDigestAlgorithm",
                    "Description": "'messageDigestAlgorithms': Message digest algorithms.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..12",
                    "type_outer": "SET OF",
                    "type_inner": "CSPSignatureAlgorithm",
                    "Description": "'signatureAlgorithms': Signature algorithms.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPSignatureAlgorithms": {
            "id": "CSPSignatureAlgorithms",
            "caption": "ASN 6-8: Signature: ASN.1 Definition for CSPSignatureAlgorithms",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3..9",
                    "type_outer": null,
                    "type_inner": "CSPSignatureAlgorithms",
                    "Description": "'CSPSignatureAlgorithms': Signature configuration for a specific resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPSignatureAlgorithm",
                    "Description": "'signatureAlgorithm': The signature algorithm.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPPaddingAlgorithm",
                    "Description": "'paddingAlgorithm': The padding algorithm.",
                    "Presence": "OPTIONAL",
                    "Default": "PAD_NULL"
                },
                {
                    "Tag": "82",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPMessageDigestAlgorithm",
                    "Description": "'messageDigestAlgorithm': The message digest algorithm.",
                    "Presence": "OPTIONAL",
                    "Default": "ALG_NULL"
                }
            ],
            "used_in": [
                "CSPAlgorithms",
                "CSPAttestationAlgorithms",
                "CSPConfigAttestation",
                "CSPDataAttestation",
                "CSPKeyPoPAttestation",
                "CSPKeyPoPAttestation"
            ]
        },
        "CSPSecureChannelSupport": {
            "id": "CSPSecureChannelSupport",
            "caption": "ASN 6-9: SecChannel: ASN.1 Definition for CSPSecureChannelSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..6",
                    "type_outer": null,
                    "type_inner": "CSPSecureChannelSupport",
                    "Description": "'CSPSecureChannelSupport': Checks for secure channel functionality support and supported protocols.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolType",
                    "Description": "'protocolTypes': Secure channel protocol types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPSecurityFunction",
                    "Description": "'securityFunctions': Secure channel security functions.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPSecureChannelSettings": {
            "id": "CSPSecureChannelSettings",
            "caption": "ASN 6-10: SecChannel: ASN.1 Definition for CSPSecureChannelSettings",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..11",
                    "type_outer": null,
                    "type_inner": "CSPSecureChannelSettings",
                    "Description": "'CSPSecureChannelSettings': General secure channel settings for the CSP Instance.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..9",
                    "type_outer": null,
                    "type_inner": "CSPTimeout",
                    "Description": "'securityTimeout': Secure channel timeout in seconds (TIMER_SECURITY_TIMEOUT).",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPSetup",
                "CSPConfiguration"
            ]
        },
        "CSPSecureChannelAlgorithms": {
            "id": "CSPSecureChannelAlgorithms",
            "caption": "ASN 6-12: SecChannel: ASN.1 Definition for CSPSecureChannelAlgorithms",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3",
                    "type_outer": null,
                    "type_inner": "CSPSecureChannelAlgorithms",
                    "Description": "'CSPSecureChannelAlgorithms': Secure channel configuration for a specific resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPSecurityFunction",
                    "Description": "'securityFunction': The security function of the protocol.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAlgorithms"
            ]
        },
        "CSPAttestationSupport": {
            "id": "CSPAttestationSupport",
            "caption": "ASN 6-14: Attestation: ASN.1 Definition for CSPAttestationSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..11",
                    "type_outer": null,
                    "type_inner": "CSPAttestationSupport",
                    "Description": "'CSPAttestationSupport': Checks for attestation functionality support and supported algorithms.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..9",
                    "type_outer": "SET OF",
                    "type_inner": "CSPResourceAttestationType",
                    "Description": "'resourceAttestationTypes': Resource attestation types, such as Data or PoP attestations.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPAttestationAlgorithms": {
            "id": "CSPAttestationAlgorithms",
            "caption": "ASN 6-17: Signature: ASN.1 Definition for CSPAttestationAlgorithms",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "7..n",
                    "type_outer": null,
                    "type_inner": "CSPAttestationAlgorithms",
                    "Description": "'CSPAttestationAlgorithms': Attestation configuration for a specific resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "5..11",
                    "type_outer": null,
                    "type_inner": "CSPSignatureAlgorithms",
                    "Description": "'signatureAlgorithms': The signature, padding and message digest algorithms.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..n",
                    "type_outer": "SEQUENCE OF",
                    "type_inner": "CSPField",
                    "Description": "'fieldsAddedAsPrefix': Add signature fields (e.g., counter) to the beginning of data to sign.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "0..n",
                    "type_outer": "SEQUENCE OF",
                    "type_inner": "CSPField",
                    "Description": "'fieldsAddedAsSuffix': Add signature fields (e.g., counter) to the end of data to sign.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAlgorithms"
            ]
        },
        "CSPPlatformAttestation": {
            "id": "CSPPlatformAttestation",
            "caption": "ASN 6-18aa: Attestations: ASN.1 Definition for CSPPlatformAttestation",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "2223..n",
                    "type_outer": null,
                    "type_inner": "CSPPlatformAttestation",
                    "Description": "'CSPPlatformAttestation': Response of a platform attestation.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "2153..n",
                    "type_outer": null,
                    "type_inner": "CSPSignedPlatformData",
                    "Description": "'signedPlatformData': The attestation data to be signed, including tags and lengths.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "64..65536",
                    "type_outer": null,
                    "type_inner": "CSPSignature",
                    "Description": "'signature': Signature over the entire signedPlatformData according to [GP Amd A].",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPSystemAttestationResponse"
            ]
        },
        "CSPSignedPlatformData": {
            "id": "CSPSignedPlatformData",
            "caption": "ASN 6-18ab: Attestations: ASN.1 Definition for CSPSignedPlatformData",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "2149..n",
                    "type_outer": null,
                    "type_inner": "CSPSignedPlatformData",
                    "Description": "'CSPSignedPlatformData': The attestation data to be signed, including tags and lengths.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Version of the CSP Admin Protocol used.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPSystemAttestationType",
                    "Description": "'attestationType': The type of the attestation being computed (i.e., platform).",
                    "Presence": "OPTIONAL",
                    "Default": "ATTESTATION_PLATFORM"
                },
                {
                    "Tag": "A2",
                    "Length": "55..66",
                    "type_outer": null,
                    "type_inner": "CSPPlatform",
                    "Description": "'platform': Information about the CSP platform.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "2048..32768",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'platform-DLOA-XML': Platform DLOA XML according to A.1 / A.2.1 of [GP DLOA].",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "84",
                    "Length": "0..32768",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'csp-application-DLOA-XML': Application DLOA according to A.1 / A.2.2 of [GP DLOA].",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "85",
                    "Length": "0..32768",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'inputData': Input data, e.g. a challenge, provided within the command.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A6",
                    "Length": "35..n",
                    "type_outer": null,
                    "type_inner": "SecurityEnvironmentTemplate",
                    "Description": "'SecurityEnvironmentTemplate': Data structure according to [GP Amd A] section 5.3.1.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPPlatformAttestation"
            ]
        },
        "ClientApplicationInformation": {
            "id": "ClientApplicationInformation",
            "caption": "ASN 6-18b: Attestations: ASN.1 Definition for ClientApplicationInformation",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "19..n",
                    "type_outer": null,
                    "type_inner": "ClientApplicationInformation",
                    "Description": "'ClientApplicationInformation': Copied from [GP Amd A] section 5.3.1 to avoid ASN.1 compiler issues.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "00",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'requestedSignatureMode': The signature mode selected by the CSP Application with init().",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "01",
                    "Length": "5..16",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'instanceAID': The AID of the CSP Application.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "02",
                    "Length": "5..16",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'executableLoadFileAID': The AID of the CSP ELF.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "03",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'executableLoadFileVersionNumber': The version of the CSP ELF; e.g., 2-byte major, minor for CAP file.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "SecurityEnvironmentTemplate"
            ]
        },
        "SecurityEnvironmentTemplate": {
            "id": "SecurityEnvironmentTemplate",
            "caption": "ASN 6-18c: Attestations: ASN.1 Definition for SecurityEnvironmentTemplate",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "33..n",
                    "type_outer": null,
                    "type_inner": "SecurityEnvironmentTemplate",
                    "Description": "'SecurityEnvironmentTemplate': Data structure according to [GP Amd A] section 5.3.1.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "00",
                    "Length": "21..n",
                    "type_outer": null,
                    "type_inner": "ClientApplicationInformation",
                    "Description": "'clientApplicationInformation': Information about the CSP Application.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "01",
                    "Length": "6..n",
                    "type_outer": null,
                    "type_inner": "AlgorithmIdentifier",
                    "Description": "'signatureAlgorithm': Information about the algorithm used by the CASD.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "02",
                    "Length": "0..n",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'keyIdentifier': Identifier of the PK.CASD-SIGN.AUT to verify the signature ([GP Amd A]).",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPSignedPlatformData"
            ]
        },
        "AlgorithmIdentifier": {
            "id": "AlgorithmIdentifier",
            "caption": "ASN 6-18d: Attestations: ASN.1 Definition for AlgorithmIdentifier",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "4..n",
                    "type_outer": null,
                    "type_inner": "AlgorithmIdentifier",
                    "Description": "'AlgorithmIdentifier': Data structure according to [GP Amd A] section 5.3.1.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "2..n",
                    "type_outer": null,
                    "type_inner": "OBJECT IDENTIFIER",
                    "Description": "'algorithm': The OID of an ECDSA algorithm as specified in [RFC 5758] section 3.2.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "SecurityEnvironmentTemplate"
            ]
        },
        "CSPConfigAttestation": {
            "id": "CSPConfigAttestation",
            "caption": "ASN 6-19a: Attestations: ASN.1 Definition for CSPConfigAttestation",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "195..98471",
                    "type_outer": null,
                    "type_inner": "CSPConfigAttestation",
                    "Description": "'CSPConfigAttestation': Response of a config attestation.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "117..32910",
                    "type_outer": null,
                    "type_inner": "CSPSignedConfigData",
                    "Description": "'signedConfigData': The attestation data to be signed, including tags and lengths.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "64..65536",
                    "type_outer": null,
                    "type_inner": "CSPSignature",
                    "Description": "'signature': Signature over the signedConfigData using the config attestation key.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "5..11",
                    "type_outer": null,
                    "type_inner": "CSPSignatureAlgorithms",
                    "Description": "'signatureAlgorithm': The algorithm used to sign the data.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPKeySizeOrCurve",
                    "Description": "'signaturKeySizeOrCurve': Key parameters of the attestation key.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPSystemAttestationResponse"
            ]
        },
        "CSPSignedConfigData": {
            "id": "CSPSignedConfigData",
            "caption": "ASN 6-19b: Attestations: ASN.1 Definition for CSPSignedConfigData",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "115..n",
                    "type_outer": null,
                    "type_inner": "CSPSignedConfigData",
                    "Description": "'CSPSignedConfigData': The attestation data to be signed, including tags and lengths.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Version of the CSP Admin Protocol used.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPSystemAttestationType",
                    "Description": "'attestationType': The type of the attestation being computed (i.e., config).",
                    "Presence": "OPTIONAL",
                    "Default": "ATTESTATION_CONFIG"
                },
                {
                    "Tag": "A2",
                    "Length": "0..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPField",
                    "Description": "'fieldsAddedAsPrefix': Additional Fields to be included; configured by the CSP Admin.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "32",
                    "type_outer": null,
                    "type_inner": "CSPConfigName",
                    "Description": "'configName': Custom name set by the CSP Admin via CSPSetup.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "84",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPConfigVersion",
                    "Description": "'configVersion': Custom version set by the CSP Admin via CSPSetup.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A5",
                    "Length": "55..66",
                    "type_outer": null,
                    "type_inner": "CSPPlatform",
                    "Description": "'cspPlatform': Information about the CSP platform.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "86",
                    "Length": "16..32768",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'inputData': Input data, e.g. a challenge, provided within the command.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A7",
                    "Length": "0..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPField",
                    "Description": "'fieldsAddedAsSuffix': Additional Fields to be included; configured by the CSP Admin.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPConfigAttestation"
            ]
        },
        "CSPDataAttestation": {
            "id": "CSPDataAttestation",
            "caption": "ASN 6-20a: Attestations: ASN.1 Definition for CSPDataAttestation",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "101..131139",
                    "type_outer": null,
                    "type_inner": "CSPDataAttestation",
                    "Description": "'CSPDataAttestation': Response of a data attestation (signature over external and internal data).",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "23..65577",
                    "type_outer": null,
                    "type_inner": "CSPSignedData",
                    "Description": "'signedData': The attestation data to be signed, including tags and lengths.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "64..65536",
                    "type_outer": null,
                    "type_inner": "CSPSignature",
                    "Description": "'signature': Signature over the signedData using the attestation key.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "5..11",
                    "type_outer": null,
                    "type_inner": "CSPSignatureAlgorithms",
                    "Description": "'signatureAlgorithm': The algorithm used to sign the data.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPKeySizeOrCurve",
                    "Description": "'signaturKeySizeOrCurve': Key parameters of the attestation key.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPResourceAttestationResponse"
            ]
        },
        "CSPSignedData": {
            "id": "CSPSignedData",
            "caption": "ASN 6-20b: Attestations: ASN.1 Definition for CSPSignedData",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "21..n",
                    "type_outer": null,
                    "type_inner": "CSPSignedData",
                    "Description": "'CSPSignedData': The attestation data to be signed, including tags and lengths.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Version of the CSP Admin Protocol used.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPResourceAttestationType",
                    "Description": "'attestationType': The type of the attestation being computed (i.e., data attestation).",
                    "Presence": "OPTIONAL",
                    "Default": "ATTESTATION_DATA"
                },
                {
                    "Tag": "A2",
                    "Length": "0..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPField",
                    "Description": "'fieldsAddedAsPrefix': Additional Fields to be included; configured by the CSP Admin.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "16..32768",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'inputData': The input data, e.g. a challenge, provided within the command.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "84",
                    "Length": "0..32768",
                    "type_outer": null,
                    "type_inner": "CSPResourceValue",
                    "Description": "'resourceValue': CSP-internal resource value: public key, counter or timer.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A5",
                    "Length": "0..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPField",
                    "Description": "'fieldsAddedAsSuffix': Additional Fields to be included; configured by the CSP Admin.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPDataAttestation"
            ]
        },
        "CSPKeyPoPAttestation": {
            "id": "CSPKeyPoPAttestation",
            "caption": "ASN 6-21a: Attestations: ASN.1 Definition for CSPKeyPoPAttestation",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "249..229478",
                    "type_outer": null,
                    "type_inner": "CSPKeyPoPAttestation",
                    "Description": "'CSPKeyPoPAttestation': Response of a key attestation including a Proof of Possession (PoP).",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "160..163900",
                    "type_outer": null,
                    "type_inner": "CSPSignedPoPData",
                    "Description": "'signedPoPData': The attestation data to be signed, including tags and lengths.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "64..65536",
                    "type_outer": null,
                    "type_inner": "CSPSignature",
                    "Description": "'signature': Signature over the entire signedPoPData using the attestation key.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "5..11",
                    "type_outer": null,
                    "type_inner": "CSPSignatureAlgorithms",
                    "Description": "'signatureAlgorithm': The algorithm used to sign the signedPoPData.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPKeySizeOrCurve",
                    "Description": "'signaturKeySizeOrCurve': Key parameters of attestation key.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A4",
                    "Length": "5..11",
                    "type_outer": null,
                    "type_inner": "CSPSignatureAlgorithms",
                    "Description": "'popSignatureAlgorithm': The algorithm used to sign the popData.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A5",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPKeySizeOrCurve",
                    "Description": "'popSignaturKeySizeOrCurve': Key parameters of the private key.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPResourceAttestationResponse"
            ]
        },
        "CSPSignedPoPData": {
            "id": "CSPSignedPoPData",
            "caption": "ASN 6-21ba: Attestations: ASN.1 Definition for CSPSignedPoPData",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "157..163895",
                    "type_outer": null,
                    "type_inner": "CSPSignedPoPData",
                    "Description": "'CSPSignedPoPData': The attestation data to be signed, including tags and lengths.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': Version of the CSP Admin Protocol used.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "86..98346",
                    "type_outer": null,
                    "type_inner": "CSPPopData",
                    "Description": "'popData': Proof Of Possession data to be signed, including tags and lengths.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "64..65536",
                    "type_outer": null,
                    "type_inner": "CSPSignature",
                    "Description": "'popDataSignature': Signature over the popData using the private key.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPKeyPoPAttestation"
            ]
        },
        "CSPPopData": {
            "id": "CSPPopData",
            "caption": "ASN 6-21bb: Attestations: ASN.1 Definition for CSPPopData",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "84..n",
                    "type_outer": null,
                    "type_inner": "CSPPopData",
                    "Description": "'CSPPopData': Proof Of Possession data to be signed, including tags and lengths.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPResourceAttestationType",
                    "Description": "'attestationType': The type of the attestation being computed (i.e., PoP).",
                    "Presence": "OPTIONAL",
                    "Default": "ATTESTATION_KEY_POP"
                },
                {
                    "Tag": "A1",
                    "Length": "0..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPField",
                    "Description": "'fieldsAddedAsPrefix': Additional Fields to be included; configured by the CSP Admin.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "64..32768",
                    "type_outer": null,
                    "type_inner": "CSPResourceValue",
                    "Description": "'publicKey': Public key value to attest.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "0..32768",
                    "type_outer": null,
                    "type_inner": "CSPResourceValue",
                    "Description": "'publicAttestationKey': Public att. key to verify the signature over signedPoPData.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "84",
                    "Length": "16..32768",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'inputData': Input data, e.g., a challenge, provided within the command.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A5",
                    "Length": "0..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPField",
                    "Description": "'fieldsAddedAsSuffix': Additional Fields to be included; configured by the CSP Admin.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPSignedPoPData"
            ]
        },
        "CSPKeySupport": {
            "id": "CSPKeySupport",
            "caption": "ASN 6-22: Key: ASN.1 Definition for CSPKeySupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..104",
                    "type_outer": null,
                    "type_inner": "CSPKeySupport",
                    "Description": "'CSPKeySupport': Checks for key management support and supported algorithms.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..57",
                    "type_outer": "SET OF",
                    "type_inner": "CSPKeySize",
                    "Description": "'keySizes': Key types, such as AES, RSA or ECC with key sizes.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..21",
                    "type_outer": "SET OF",
                    "type_inner": "CSPCurve",
                    "Description": "'curves': Curves / ECC domain parameter sets.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "0..12",
                    "type_outer": "SET OF",
                    "type_inner": "CSPKeyDerivationAlgorithm",
                    "Description": "'keyDerivationAlgorithms': Key derivation alorithms.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "0..6",
                    "type_outer": "SET OF",
                    "type_inner": "CSPKeyAgreementScheme",
                    "Description": "'keyAgreementSchemes': Key agreement schemes.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPKey": {
            "id": "CSPKey",
            "caption": "ASN 6-23: Key: ASN.1 Definition for CSPKey",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..12",
                    "type_outer": null,
                    "type_inner": "CSPKey",
                    "Description": "'CSPKey': Additional attributes required by key resources.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPKeyType",
                    "Description": "'type': The cryptographic keyType.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPKeySize",
                    "Description": "'size': The cryptographic keySize; also mandatory for ECC keys.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPCurve",
                    "Description": "'curve': ECC curve parameters; only relevant for ECC keys.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "BOOLEAN",
                    "Description": "'transient': Flag indicating the key is transient.",
                    "Presence": "OPTIONAL",
                    "Default": "FALSE"
                }
            ],
            "used_in": [
                "CSPResourceParams"
            ]
        },
        "CSPKeyDerivationAlgorithms": {
            "id": "CSPKeyDerivationAlgorithms",
            "caption": "ASN 6-28: Cipher: ASN.1 Definition for CSPKeyDerivationAlgorithms",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3..6",
                    "type_outer": null,
                    "type_inner": "CSPKeyDerivationAlgorithms",
                    "Description": "'CSPKeyDerivationAlgorithms': Key derivation configuration for a specific resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPKeyDerivationAlgorithm",
                    "Description": "'keyDerivationAlgorithm': The key derivation algorithm.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPMessageDigestAlgorithm",
                    "Description": "'keyDerivationHashAlgorithm': The hash algorithm used for the key derivation.",
                    "Presence": "OPTIONAL",
                    "Default": "ALG_NULL"
                }
            ],
            "used_in": [
                "CSPAlgorithms"
            ]
        },
        "CSPCertificateSupport": {
            "id": "CSPCertificateSupport",
            "caption": "ASN 6-31: Certificate: ASN.1 Definition for CSPCertificateSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..8",
                    "type_outer": null,
                    "type_inner": "CSPCertificateSupport",
                    "Description": "'CSPCertificateSupport': Checks for certificate management support and supported certificate types.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..6",
                    "type_outer": "SET OF",
                    "type_inner": "CSPCertificateType",
                    "Description": "'certificateTypes': Certificate types, such as CVC or X.509.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPCertificate": {
            "id": "CSPCertificate",
            "caption": "ASN 6-32: Certificate: ASN.1 Definition for CSPCertificate",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3",
                    "type_outer": null,
                    "type_inner": "CSPCertificate",
                    "Description": "'CSPCertificate': Additional attributes required by certificate resources.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPCertificateType",
                    "Description": "'type': The certificateType of the certificate.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPResourceParams"
            ]
        },
        "CSPPasswordSupport": {
            "id": "CSPPasswordSupport",
            "caption": "ASN 6-34: Password: ASN.1 Definition for CSPPasswordSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..17",
                    "type_outer": null,
                    "type_inner": "CSPPasswordSupport",
                    "Description": "'CSPPasswordSupport': Checks for password support and supported password types.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..15",
                    "type_outer": "SET OF",
                    "type_inner": "CSPPasswordType",
                    "Description": "'passwordTypes': Password types, such as numbers only or strong with special characters.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPPassword": {
            "id": "CSPPassword",
            "caption": "ASN 6-35: Password: ASN.1 Definition for CSPPassword",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3..12",
                    "type_outer": null,
                    "type_inner": "CSPPassword",
                    "Description": "'CSPPassword': Additional attributes required by password resources.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPPasswordType",
                    "Description": "'type': The passwordType paramter of the password.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "'minSize': Minimum number of password characters allowed.",
                    "Presence": "OPTIONAL",
                    "Default": "4"
                },
                {
                    "Tag": "82",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "'maxSize': Maximum number of password characters allowed.",
                    "Presence": "OPTIONAL",
                    "Default": "20"
                },
                {
                    "Tag": "83",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "'tryLimit': Incorrect password attempts allowed before blocked (disabled if 0xFF).",
                    "Presence": "OPTIONAL",
                    "Default": "255"
                }
            ],
            "used_in": [
                "CSPResourceParams"
            ]
        },
        "CSPCounterSupport": {
            "id": "CSPCounterSupport",
            "caption": "ASN 6-37: Counter: ASN.1 Definition for CSPCounterSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..51",
                    "type_outer": null,
                    "type_inner": "CSPCounterSupport",
                    "Description": "'CSPCounterSupport': Checks for counter functionality support and supported counter types.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..9",
                    "type_outer": "SET OF",
                    "type_inner": "CSPCounterMode",
                    "Description": "'counterModes': Counter operation modes to specify the handling of unsupported counters.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..21",
                    "type_outer": "SET OF",
                    "type_inner": "CSPCounterType",
                    "Description": "'counterTypes': Counter types.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "0..12",
                    "type_outer": "SET OF",
                    "type_inner": "CSPCounterCapacity",
                    "Description": "'counterCapacitites': Counter capacitites.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "'largeCounterLimit': Maximum number of counters with large capacity.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPCounterSettings": {
            "id": "CSPCounterSettings",
            "caption": "ASN 6-38: Counter: ASN.1 Definition for CSPCounterSettings",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3",
                    "type_outer": null,
                    "type_inner": "CSPCounterSettings",
                    "Description": "'CSPCounterSettings': General counter settings for the CSP Instance.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPCounterMode",
                    "Description": "'counterMode': Select counter mode specify the handling of unavailable counter types.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPSetup",
                "CSPConfiguration"
            ]
        },
        "CSPCounters": {
            "id": "CSPCounters",
            "caption": "ASN 6-41: Counter: ASN.1 Definition for CSPCounters",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..78",
                    "type_outer": null,
                    "type_inner": "CSPCounters",
                    "Description": "'CSPCounters': Container for built-in counters that can be configured to a resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..11",
                    "type_outer": null,
                    "type_inner": "CSPCounter",
                    "Description": "'usageCounter': Counter of type COUNT_USAGE.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..11",
                    "type_outer": null,
                    "type_inner": "CSPCounter",
                    "Description": "'blockUsageCounter': Counter of type COUNT_USAGE_PER_BLOCK.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "0..11",
                    "type_outer": null,
                    "type_inner": "CSPCounter",
                    "Description": "'successCounter': Counter of type COUNT_USAGE_SUCCESS_ONLY.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "0..11",
                    "type_outer": null,
                    "type_inner": "CSPCounter",
                    "Description": "'failureCounter': Counter of type COUNT_USAGE_FAILURE_ONLY.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A4",
                    "Length": "0..11",
                    "type_outer": null,
                    "type_inner": "CSPCounter",
                    "Description": "'authUsageCounter': Counter of type COUNT_AUTH_USAGE.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A5",
                    "Length": "0..11",
                    "type_outer": null,
                    "type_inner": "CSPCounter",
                    "Description": "'transportUsageCounter': Counter of type COUNT_TRANSPORT_USAGE.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPConfigureResource",
                "CSPResource"
            ]
        },
        "CSPCounter": {
            "id": "CSPCounter",
            "caption": "ASN 6-42: Counter: ASN.1 Definition for CSPCounter",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..9",
                    "type_outer": null,
                    "type_inner": "CSPCounter",
                    "Description": "'CSPCounter': Data structure for a counter configuration.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPCounterCapacity",
                    "Description": "'counterCapacity': The structure of the counter defines the max increments supported.",
                    "Presence": "OPTIONAL",
                    "Default": "COUNTER_MEDIUM"
                },
                {
                    "Tag": "81",
                    "Length": "0..4",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'counterLimit': Maximum counter limit before the counter exceeds; is 0 when disabled.",
                    "Presence": "OPTIONAL",
                    "Default": "{ }"
                }
            ],
            "used_in": [
                "CSPResourceParams",
                "CSPCounters",
                "CSPCounters",
                "CSPCounters",
                "CSPCounters",
                "CSPCounters",
                "CSPCounters"
            ]
        },
        "CSPTimeSupport": {
            "id": "CSPTimeSupport",
            "caption": "ASN 6-44: Time: ASN.1 Definition for CSPTimeSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..48",
                    "type_outer": null,
                    "type_inner": "CSPTimeSupport",
                    "Description": "'CSPTimeSupport': Checks for time management support and supported timer types.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..9",
                    "type_outer": "SET OF",
                    "type_inner": "CSPTimeMode",
                    "Description": "'timeModes': Time operation modes to specify the handling for unsupported time.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPTimeSynchronization",
                    "Description": "'timeSynchonization': Time synchronization strategies.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "0..21",
                    "type_outer": "SET OF",
                    "type_inner": "CSPTimerType",
                    "Description": "'timerTypes': Timer types, such as validity date or authentication timeout.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "0..9",
                    "type_outer": "SET OF",
                    "type_inner": "CSPTimeoutType",
                    "Description": "'timeoutTypes': Timeout types to specify if a timeout timer is refreshed.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPTimeSettings": {
            "id": "CSPTimeSettings",
            "caption": "ASN 6-45: Time: ASN.1 Definition for CSPTimeSettings",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..10",
                    "type_outer": null,
                    "type_inner": "CSPTimeSettings",
                    "Description": "'CSPTimeSettings': General time configuration settings for the CSP Instance.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPTimeMode",
                    "Description": "'timeMode': Select time mode to specify the handling of unavailable system time.",
                    "Presence": "OPTIONAL",
                    "Default": "TIME_MODE_OFF"
                },
                {
                    "Tag": "81",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPTimeSynchronization",
                    "Description": "'timeSynchonization': Configure a strategy to syncronize the reference time.",
                    "Presence": "OPTIONAL",
                    "Default": "{ }"
                },
                {
                    "Tag": "82",
                    "Length": "0..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'timeVerificationKey': A public key to verify signatures of new timestamps.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPSetup",
                "CSPConfiguration"
            ]
        },
        "CSPTimers": {
            "id": "CSPTimers",
            "caption": "ASN 6-49: Time: ASN.1 Definition for CSPTimers",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..30",
                    "type_outer": null,
                    "type_inner": "CSPTimers",
                    "Description": "'CSPTimers': Container for built-in timers that can be configured to a resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "0..4",
                    "type_outer": null,
                    "type_inner": "CSPDuration",
                    "Description": "'validityPeriod': Validity period for key or password (TIMER_VALIDITY_PERIOD).",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..8",
                    "type_outer": null,
                    "type_inner": "CSPTimestamp",
                    "Description": "'validityDate': Validity date for key or password (TIMER_VALIDITY_DATE).",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "BOOLEAN",
                    "Description": "'validityCertificate': Validity date from certificate (TIMER_VALIDITY_CERTIFICATE).",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A3",
                    "Length": "0..9",
                    "type_outer": null,
                    "type_inner": "CSPTimeout",
                    "Description": "'authTimeout': Authentication timeout for passwords (TIMER_AUTH_TIMEOUT).",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPConfigureResource",
                "CSPResource"
            ]
        },
        "CSPTimeout": {
            "id": "CSPTimeout",
            "caption": "ASN 6-52: Time: ASN.1 Definition for CSPTimeout",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "4..7",
                    "type_outer": null,
                    "type_inner": "CSPTimeout",
                    "Description": "'CSPTimeout': Timeout in seconds, represented as 2-byte signed integer (up to 9 hours).",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "2",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'timeoutValue': Maximum time limit before the timer expires.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPTimeoutType",
                    "Description": "'timeoutType': Specifys if the timeout value is re-computed on each resource usage.",
                    "Presence": "OPTIONAL",
                    "Default": "TIMEOUT_HARD"
                }
            ],
            "used_in": [
                "CSPSecureChannelSettings",
                "CSPTimers",
                "CSPManualTimer"
            ]
        },
        "CSPAuditSupport": {
            "id": "CSPAuditSupport",
            "caption": "ASN 6-55: Audit: ASN.1 Definition for CSPAuditSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..133",
                    "type_outer": null,
                    "type_inner": "CSPAuditSupport",
                    "Description": "'CSPAuditSupport': Checks for secure auditing support and supported events.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..9",
                    "type_outer": "SET OF",
                    "type_inner": "CSPAuditMode",
                    "Description": "'auditModes': Audit operation modes to specify the handling for unsupported events.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..18",
                    "type_outer": "SET OF",
                    "type_inner": "CSPSystemEvent",
                    "Description": "'systemEvents': Event types of category \"system event\".",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "0..100",
                    "type_outer": "SET OF",
                    "type_inner": "CSPResourceEvent",
                    "Description": "'resourceEvents': Event types of category \"resource event\".",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPAuditSettings": {
            "id": "CSPAuditSettings",
            "caption": "ASN 6-56: Audit: ASN.1 Definition for CSPAuditSettings",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..27",
                    "type_outer": null,
                    "type_inner": "CSPAuditSettings",
                    "Description": "'CSPAuditSettings': Audit configuration for this CSP Instance.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPAuditMode",
                    "Description": "'auditMode': Select audit mode to specify the handling of a full audit event queue.",
                    "Presence": "OPTIONAL",
                    "Default": "AUDIT_MODE_OFF"
                },
                {
                    "Tag": "A1",
                    "Length": "0..18",
                    "type_outer": "SET OF",
                    "type_inner": "CSPSystemEvent",
                    "Description": "'systemEvents': The system events that shall be audited.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'auditSigningKey': The key that shall be used to sign the audit log messages.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPSetup",
                "CSPConfiguration"
            ]
        },
        "CSPLogMessage": {
            "id": "CSPLogMessage",
            "caption": "ASN 6-60: Audit: ASN.1 Definition for CSPLogMessage",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3..n",
                    "type_outer": null,
                    "type_inner": "CSPLogMessage",
                    "Description": "'CSPLogMessage': Log message format, computed by the audit.dequeueEvent operation.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "'eventType': Event type; value can be taken from CSPSystemEvent or CSPResourceEvent.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPField",
                    "Description": "'fieldsAddedAsPrefix': Additional Fields to be included; configured by the CSP Admin.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "0..44",
                    "type_outer": null,
                    "type_inner": "CSPEventData",
                    "Description": "'eventData': Event-specific log data.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "0..65536",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'inputData': Additional input data provided by the Client through audit.dequeueEvent.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A4",
                    "Length": "0..n",
                    "type_outer": "SET OF",
                    "type_inner": "CSPField",
                    "Description": "'fieldsAddedAsSuffix': Additional Fields to be included; configured by the CSP Admin.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": []
        },
        "CSPEventDataUpdateCSP": {
            "id": "CSPEventDataUpdateCSP",
            "caption": "ASN 6-62: Audit: ASN.1 Definition for CSPEventDataUpdateCSP",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "14",
                    "type_outer": null,
                    "type_inner": "CSPEventDataUpdateCSP",
                    "Description": "'CSPEventDataUpdateCSP': Event-specific data for 'CSP software update started or has finished'.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "2",
                    "type_outer": null,
                    "type_inner": "CSPELFVersion",
                    "Description": "'oldCSPELFVersion': The cspELFVersion of the CSP ELF of the before the SW update.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "2",
                    "type_outer": null,
                    "type_inner": "CSPELFVersion",
                    "Description": "'newCSPELFVersion': The cspELFVersion of the CSP ELF after the SW update.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'cspProtocolVersion': The version of the CSP Protocol before the SW update.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "83",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPProtocolVersion",
                    "Description": "'newProtocolVersion': The cspProtocolVersion of the CSP Protocol after the SW update.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEventData"
            ]
        },
        "CSPEventDataUpdateConfig": {
            "id": "CSPEventDataUpdateConfig",
            "caption": "ASN 6-63: Audit: ASN.1 Definition for CSPEventDataUpdateConfig",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "40..42",
                    "type_outer": null,
                    "type_inner": "CSPEventDataUpdateConfig",
                    "Description": "'CSPEventDataUpdateConfig': Event-specific data for EVENT_CSP_CONFIG_UPDATED: Config updated.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "32",
                    "type_outer": null,
                    "type_inner": "CSPConfigName",
                    "Description": "'configName': Custom name or identifier set by the CSP Admin via CSPSetup.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPConfigVersion",
                    "Description": "'oldConfigVersion': The old configVersion of the CSP Configuration before the update.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPConfigVersion",
                    "Description": "'newConfigVersion': The new configVersion of the CSP Configuration after the update.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEventData"
            ]
        },
        "CSPEventDataSetTime": {
            "id": "CSPEventDataSetTime",
            "caption": "ASN 6-64: Audit: ASN.1 Definition for CSPEventDataSetTime",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "20",
                    "type_outer": null,
                    "type_inner": "CSPEventDataSetTime",
                    "Description": "'CSPEventDataSetTime': Event-specific data for EVENT_CSP_TIME_SET: Reference time updated.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "8",
                    "type_outer": null,
                    "type_inner": "CSPTimestamp",
                    "Description": "'oldReferenceTime': The old referenceTime as it was before the update.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "8",
                    "type_outer": null,
                    "type_inner": "CSPTimestamp",
                    "Description": "'newReferenceTime': The new referenceTime after the update.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEventData"
            ]
        },
        "CSPEventDataGeneralError": {
            "id": "CSPEventDataGeneralError",
            "caption": "ASN 6-65: Audit: ASN.1 Definition for CSPEventDataGeneralError",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "4..8",
                    "type_outer": null,
                    "type_inner": "CSPEventDataGeneralError",
                    "Description": "'CSPEventDataGeneralError': Event-specific data for EVENT_CSP_ERROR: An exception occurred.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "2",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'reason': Contains the reason of the exception that occurred.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'resourceId': A resource ID involved to the error (if available).",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEventData"
            ]
        },
        "CSPEventDataResource": {
            "id": "CSPEventDataResource",
            "caption": "ASN 6-66: Audit: ASN.1 Definition for CSPEventDataResource",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3..4",
                    "type_outer": null,
                    "type_inner": "CSPEventDataResource",
                    "Description": "'CSPEventDataResource': Event-specific data for general resource-specific events.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'resourceId': The identifier of the resource that triggered this event.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEventData"
            ]
        },
        "CSPEventDataKeyDerivation": {
            "id": "CSPEventDataKeyDerivation",
            "caption": "ASN 6-67: Audit: ASN.1 Definition for CSPEventDataKeyDerivation",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..8",
                    "type_outer": null,
                    "type_inner": "CSPEventDataKeyDerivation",
                    "Description": "'CSPEventDataKeyDerivation': Event-specific data for EVENT_KEY_DERIVED: Successful key derivation.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'sourceResourceId': The source resource for key derivation.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'destResourceId': The target resource where the result is stored.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEventData"
            ]
        },
        "CSPEventDataKeyAgreement": {
            "id": "CSPEventDataKeyAgreement",
            "caption": "ASN 6-68: Audit: ASN.1 Definition for CSPEventDataKeyAgreement",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "9..12",
                    "type_outer": null,
                    "type_inner": "CSPEventDataKeyAgreement",
                    "Description": "'CSPEventDataKeyAgreement': Event-specific data for EVENT_KEY_SHARED_SECRET_COMPUTED: Key agreement.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'privateKeyId': The local or remote private key.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'publicKeyId': The local or remote public key.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'sharedSecretId': The resource ID of the destination shared secret.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEventData"
            ]
        },
        "CSPEventDataPasswordFailure": {
            "id": "CSPEventDataPasswordFailure",
            "caption": "ASN 6-69: Audit: ASN.1 Definition for CSPEventDataPasswordFailure",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..7",
                    "type_outer": null,
                    "type_inner": "CSPEventDataPasswordFailure",
                    "Description": "'CSPEventDataPasswordFailure': Event-specific data for EVENT_PASSWORD_CHECK_FAILED: Verification failed.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'resourceId': The identifier of the resource that triggered this event.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "'tryCounter': The remaining try counter value.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEventData"
            ]
        },
        "CSPFieldSupport": {
            "id": "CSPFieldSupport",
            "caption": "ASN 6-70: Access: ASN.1 Definition for CSPFieldSupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..60",
                    "type_outer": null,
                    "type_inner": "CSPFieldSupport",
                    "Description": "'CSPFieldSupport': Checks for signing field functionality support.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..9",
                    "type_outer": "SET OF",
                    "type_inner": "CSPFieldMode",
                    "Description": "'fieldModes': CSP handling modes of how to handle signature fields.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..39",
                    "type_outer": "SET OF",
                    "type_inner": "CSPFieldType",
                    "Description": "'fieldTypes': Signature fields to be added to log messages and attestation data.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A2",
                    "Length": "0..6",
                    "type_outer": "SET OF",
                    "type_inner": "CSPFieldSource",
                    "Description": "'fieldSources': Available data sources for fields.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPFieldSettings": {
            "id": "CSPFieldSettings",
            "caption": "ASN 6-71: Audit: ASN.1 Definition for CSPFieldSettings",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..3",
                    "type_outer": null,
                    "type_inner": "CSPFieldSettings",
                    "Description": "'CSPFieldSettings': Field configuration for this CSP Instance.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "0..1",
                    "type_outer": null,
                    "type_inner": "CSPFieldMode",
                    "Description": "'fieldMode': Select the mode for handling unsupported fields.",
                    "Presence": "OPTIONAL",
                    "Default": "FIELD_MODE_OFF"
                }
            ],
            "used_in": [
                "CSPSetup",
                "CSPConfiguration"
            ]
        },
        "CSPField": {
            "id": "CSPField",
            "caption": "ASN 6-73a: Signature: ASN.1 Definition for CSPField",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..7",
                    "type_outer": null,
                    "type_inner": "CSPField",
                    "Description": "'CSPField': Structure to configure a field for attestation data or log messages.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPFieldType",
                    "Description": "'field': Type of the data field.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPSource",
                    "Description": "'source': Source from which the data is taken for the field.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAttestationAlgorithms",
                "CSPAttestationAlgorithms",
                "CSPSignedConfigData",
                "CSPSignedConfigData",
                "CSPSignedData",
                "CSPSignedData",
                "CSPPopData",
                "CSPPopData",
                "CSPLogMessage",
                "CSPLogMessage"
            ]
        },
        "CSPFieldValue": {
            "id": "CSPFieldValue",
            "caption": "ASN 6-76: Signature: ASN.1 Definition for CSPFieldValue",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "5..65548",
                    "type_outer": null,
                    "type_inner": "CSPFieldValue",
                    "Description": "'CSPFieldValue': The concrete value of a data field added to data before it is signed.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPFieldType",
                    "Description": "'field': Type of the data field.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "0..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'resourceId': The resource used as the data source.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..65536",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'fieldValue': The value of the field.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": []
        },
        "CSPPolicySupport": {
            "id": "CSPPolicySupport",
            "caption": "ASN 6-77: Access: ASN.1 Definition for CSPPolicySupport",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "0..34",
                    "type_outer": null,
                    "type_inner": "CSPPolicySupport",
                    "Description": "'CSPPolicySupport': Supported policy features.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "A0",
                    "Length": "0..9",
                    "type_outer": "SET OF",
                    "type_inner": "CSPPolicyMode",
                    "Description": "'policyModes': Policy operation modes to specify the handling of unsupported policies.",
                    "Presence": "OPTIONAL",
                    "Default": null
                },
                {
                    "Tag": "A1",
                    "Length": "0..21",
                    "type_outer": "SET OF",
                    "type_inner": "CSPPolicyType",
                    "Description": "'policyTypes': Policy types, e.g., require an authenticated password to allow cipher.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPEnforce"
            ]
        },
        "CSPPolicySettings": {
            "id": "CSPPolicySettings",
            "caption": "ASN 6-78: Access: ASN.1 Definition for CSPPolicySettings",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "3",
                    "type_outer": null,
                    "type_inner": "CSPPolicySettings",
                    "Description": "'CSPPolicySettings': General policy settings for the CSP Instance.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPPolicyMode",
                    "Description": "'policyMode': Select policy mode to specify the handling of unavailable counter types.",
                    "Presence": null,
                    "Default": null
                }
            ],
            "used_in": [
                "CSPSetup",
                "CSPConfiguration"
            ]
        },
        "CSPPolicy": {
            "id": "CSPPolicy",
            "caption": "ASN 6-80: Access: ASN.1 Definition for CSPPolicy",
            "table": [
                {
                    "Tag": "SEQUENCE",
                    "Length": "6..17",
                    "type_outer": null,
                    "type_inner": "CSPPolicy",
                    "Description": "'CSPPolicy': Structure to configure advanced access rules for a resource.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "80",
                    "Length": "1",
                    "type_outer": null,
                    "type_inner": "CSPPolicyType",
                    "Description": "'policyType': The additional condition that needs to be checked.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "81",
                    "Length": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "'constrainingResourceId': The associated resource that is evaluated for the policy.",
                    "Presence": null,
                    "Default": null
                },
                {
                    "Tag": "82",
                    "Length": "0..8",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "'additionalData': Policy specific data, e.g., required TA access rights.",
                    "Presence": "OPTIONAL",
                    "Default": null
                }
            ],
            "used_in": [
                "CSPAccessControl"
            ]
        }
    },
    "ENUMERATED": {
        "CSPMode": {
            "id": "CSPMode",
            "caption": "ASN 5-5: Core: ASN.1 Definition for CSPMode",
            "table": [
                {
                    "Name": "CSP_MODE_CONFIGURATION",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The CSP can be configured by the CSP Admin."
                },
                {
                    "Name": "CSP_MODE_OPERATIONAL",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The CSP can be used by Client Applications."
                }
            ],
            "used_in": [
                "CSPConfiguration"
            ]
        },
        "CSPErrorMode": {
            "id": "CSPErrorMode",
            "caption": "ASN 5-8: Core: ASN.1 Definition for CSPErrorMode",
            "table": [
                {
                    "Name": "ERROR_MODE_BASIC",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The CSP uses only codes 1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000."
                },
                {
                    "Name": "ERROR_MODE_DETAILED",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The CSP uses detailed error codes 1xxx-8xxx."
                }
            ],
            "used_in": [
                "CSPCoreSupport",
                "CSPSettings"
            ]
        },
        "CSPResourceState": {
            "id": "CSPResourceState",
            "caption": "ASN 5-19: Resource: ASN.1 Definition for CSPResourceState",
            "table": [
                {
                    "Name": "STATE_UNINITIALIZED",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Uninitialized state for resources."
                },
                {
                    "Name": "STATE_OPERATIONAL",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Operational state for resources."
                },
                {
                    "Name": "STATE_BLOCKED",
                    "Value": "9",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Blocked state when the password try limit is reached."
                },
                {
                    "Name": "STATE_EXHAUSTED",
                    "Value": "11",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Exhausted state when a counter exceeds the configured limit."
                },
                {
                    "Name": "STATE_EXPIRED",
                    "Value": "12",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Expired state when a timer expires."
                }
            ],
            "used_in": []
        },
        "CSPResourceType": {
            "id": "CSPResourceType",
            "caption": "ASN 5-21: Resource: ASN.1 Definition for CSPResourceType",
            "table": [
                {
                    "Name": "RESOURCE_KEY",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Key resource type."
                },
                {
                    "Name": "RESOURCE_CERTIFICATE",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Certificate resource type."
                },
                {
                    "Name": "RESOURCE_PASSWORD",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Password resource type."
                },
                {
                    "Name": "RESOURCE_COUNTER",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Counter resource type."
                },
                {
                    "Name": "RESOURCE_TIMER",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Timer resource type."
                }
            ],
            "used_in": [
                "CSPResourceSupport"
            ]
        },
        "CSPUsageType": {
            "id": "CSPUsageType",
            "caption": "ASN 5-22: Resource: ASN.1 Definition for CSPUsageType",
            "table": [
                {
                    "Name": "USAGE_CIPHER",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Restrict the use to cipher operations (keys)."
                },
                {
                    "Name": "USAGE_SIGNATURE",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Restrict the use to signature operations (keys)."
                },
                {
                    "Name": "USAGE_TRANSFORM",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Restrict the use to encryption transformation operations (keys)."
                },
                {
                    "Name": "USAGE_SECCHANNEL",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Restrict the use to secure message establishment (any)."
                },
                {
                    "Name": "USAGE_CONFIDENTIAL",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Restrict the use to confidential data transfer (keys)."
                },
                {
                    "Name": "USAGE_ATTESTATION",
                    "Value": "6",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Restrict the use as attestation signing key (keys)."
                },
                {
                    "Name": "USAGE_KEY",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Restrict the use to key derivation and key agreement (any)."
                },
                {
                    "Name": "USAGE_PASSWORD",
                    "Value": "9",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Restrict the use to password verification (passwords only)."
                },
                {
                    "Name": "USAGE_AUDIT",
                    "Value": "12",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Restrict the use as audit log message signing key (keys)."
                },
                {
                    "Name": "USAGE_OFFLOADING",
                    "Value": "13",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Restrict the use as offloading key for resource import/export (keys)."
                }
            ],
            "used_in": [
                "CSPResource"
            ]
        },
        "CSPPaddingAlgorithm": {
            "id": "CSPPaddingAlgorithm",
            "caption": "ASN 6-3: Cipher: ASN.1 Definition for CSPPaddingAlgorithm",
            "table": [
                {
                    "Name": "PAD_NULL",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "No padding; for use when padding is not supported by the algorithm."
                },
                {
                    "Name": "PAD_NOPAD",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "No padding is applied to the data, even when the algorithm usually pads."
                },
                {
                    "Name": "PAD_ISO9797_1_M2_ALG3",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Padding based on the ISO 9797-1 MAC algo 3 with method 2 [ISO 9797-1]."
                },
                {
                    "Name": "PAD_PKCS1",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Padding based on the PKCS#1 v1.5 scheme [RFC 8017]."
                },
                {
                    "Name": "PAD_PKCS1_PSS",
                    "Value": "8",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Padding based on the PKCS#1-PSS scheme [IEEE 1363-2000]."
                },
                {
                    "Name": "PAD_PKCS1_OAEP_SHA256",
                    "Value": "14",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Padding based on the PKCS#1-OAEP scheme [IEEE 1363-2000] with SHA256."
                },
                {
                    "Name": "PAD_PKCS1_OAEP_SHA384",
                    "Value": "15",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Padding based on the PKCS#1-OAEP scheme [IEEE 1363-2000] with SHA384."
                },
                {
                    "Name": "PAD_PKCS1_OAEP_SHA512",
                    "Value": "16",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Padding based on the PKCS#1-OAEP scheme [IEEE 1363-2000] with SHA512."
                },
                {
                    "Name": "PAD_PKCS1_OAEP_SHA3_256",
                    "Value": "18",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Padding based on the PKCS#1-OAEP scheme [IEEE 1363-2000] with SHA3-256."
                },
                {
                    "Name": "PAD_PKCS1_OAEP_SHA3_384",
                    "Value": "19",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Padding based on the PKCS#1-OAEP scheme [IEEE 1363-2000] with SHA3-384."
                },
                {
                    "Name": "PAD_PKCS1_OAEP_SHA3_512",
                    "Value": "20",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Padding based on the PKCS#1-OAEP scheme [IEEE 1363-2000] with SHA3-512."
                },
                {
                    "Name": "PAD_PKCS7",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Padding based on the PKCS#7 scheme [RFC 5652]."
                }
            ],
            "used_in": [
                "CSPCipherSupport",
                "CSPCipherAlgorithms",
                "CSPSignatureAlgorithms"
            ]
        },
        "CSPCipherAlgorithm": {
            "id": "CSPCipherAlgorithm",
            "caption": "ASN 6-4: Cipher: ASN.1 Definition for CSPCipherAlgorithm",
            "table": [
                {
                    "Name": "CIPHER_AES_CBC",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Cipher using AES [FIPS 197] with block size 128 in CBC mode [FIPS 81]."
                },
                {
                    "Name": "CIPHER_AES_CFB",
                    "Value": "28",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Cipher using AES [FIPS 197] in Cipher Feedback (CFB) mode [FIPS 81]."
                },
                {
                    "Name": "CIPHER_AES_CTR",
                    "Value": "240",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Cipher using AES [FIPS 197] in counter (CTR) mode [ISO 10116]."
                },
                {
                    "Name": "CIPHER_AES_GCM",
                    "Value": "241",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Cipher using AES [FIPS 197] Galois/Counter Mode [SP800-38D]."
                },
                {
                    "Name": "CIPHER_AES_CCM",
                    "Value": "242",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Cipher using AES [FIPS 197] in Counter with CBC-MAC mode [SP800-38C]."
                },
                {
                    "Name": "CIPHER_AES_XTS",
                    "Value": "10",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Cipher using AES [FIPS 197] in XTS mode in [IEEE 1619-2018]."
                },
                {
                    "Name": "CIPHER_RSA",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Cipher using RSA [PKCS #1]."
                }
            ],
            "used_in": [
                "CSPCipherSupport",
                "CSPCipherAlgorithms"
            ]
        },
        "CSPMessageDigestAlgorithm": {
            "id": "CSPMessageDigestAlgorithm",
            "caption": "ASN 6-6: Signature: ASN.1 Definition for CSPMessageDigestAlgorithm",
            "table": [
                {
                    "Name": "ALG_NULL",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "No message digest is applied to the data."
                },
                {
                    "Name": "ALG_SHA_256",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "SHA-256 [FIPS 81] with block size of 64 and hash size of 32 bytes."
                },
                {
                    "Name": "ALG_SHA_384",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "SHA-384 [FIPS 81] with block size of 128 and hash value of 64 bytes."
                },
                {
                    "Name": "ALG_SHA_512",
                    "Value": "6",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "SHA-512 [FIPS 81] with block size of 128 and hash size of 64 bytes."
                },
                {
                    "Name": "ALG_SHA3_256",
                    "Value": "9",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "SHA3-256 [FIPS 180-4] with block size of 64 and hash size of 32 bytes."
                },
                {
                    "Name": "ALG_SHA3_384",
                    "Value": "10",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "SHA3-384 [FIPS 180-4] with block size of 128 and hash size of 64 bytes."
                },
                {
                    "Name": "ALG_SHA3_512",
                    "Value": "11",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "SHA3-512 [FIPS 180-4] with block size of 128 and hash size of 64 bytes."
                }
            ],
            "used_in": [
                "CSPSignatureSupport",
                "CSPSignatureAlgorithms",
                "CSPKeyDerivationAlgorithms"
            ]
        },
        "CSPSignatureAlgorithm": {
            "id": "CSPSignatureAlgorithm",
            "caption": "ASN 6-7: Signature: ASN.1 Definition for CSPSignatureAlgorithm",
            "table": [
                {
                    "Name": "SIG_AES_CMAC128",
                    "Value": "10",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Signature according to [ISO 9797-1]: AES 128-bit block and 16-byte CMAC."
                },
                {
                    "Name": "SIG_AES_MAC128",
                    "Value": "6",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Signature according to [SP800-38B]: AES 128-bit block and 16-byte MAC."
                },
                {
                    "Name": "SIG_HMAC",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Signature using HMAC according to [FIPS 198-1]."
                },
                {
                    "Name": "SIG_RSA",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "RSA signature according to [IEEE 1363-2000] with PKCS#1-PSS."
                }
            ],
            "used_in": [
                "CSPSignatureSupport",
                "CSPSignatureAlgorithms"
            ]
        },
        "CSPProtocolType": {
            "id": "CSPProtocolType",
            "caption": "ASN 6-11: SecChannel: ASN.1 Definition for CSPProtocolType",
            "table": [
                {
                    "Name": "PROTOCOL_PACE",
                    "Value": "17",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Password Authenticated Connection Establishment [TR-03110-3]."
                },
                {
                    "Name": "PROTOCOL_EAC_ID",
                    "Value": "18",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Extended Access Control v2 (PACE, TA2, CA2, CA3) [TR-03110-3]."
                },
                {
                    "Name": "PROTOCOL_EAC_MRTD",
                    "Value": "19",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Extended Access Control v1 (PACE, CA1, TA1) [ICAO 9303-11]."
                },
                {
                    "Name": "PROTOCOL_PACE_CAM",
                    "Value": "20",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "PACE with Chip Authentication Mapping (PACE, CA1, TA1) [ICAO 9303-11]."
                },
                {
                    "Name": "PROTOCOL_SCP03",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "GP Secure Channel Protocol '03' [GP Amd D]."
                },
                {
                    "Name": "PROTOCOL_SCP04",
                    "Value": "21",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "GP Secure Channel Protocol '04' [GP Amd K]."
                }
            ],
            "used_in": [
                "CSPClient",
                "CSPSecureChannelSupport"
            ]
        },
        "CSPSecurityFunction": {
            "id": "CSPSecurityFunction",
            "caption": "ASN 6-13: SecChannel: ASN.1 Definition for CSPSecurityFunction",
            "table": [
                {
                    "Name": "SEC_PACE_PIN",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Password Authenticated Connection Establishment (PACE) PIN [TR-03110-2]."
                },
                {
                    "Name": "SEC_PACE_PUK",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Personal Unblocking Key (PUK) for PACE [TR-03110-2]."
                },
                {
                    "Name": "SEC_PACE_CAN",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Personal Unblocking Key (PUK) for PACE [TR-03110-1]."
                },
                {
                    "Name": "SEC_PACE_MRZ",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Personal Unblocking Key (PUK) for PACE [TR-03110-2]."
                },
                {
                    "Name": "SEC_TA_AT_ROOT",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Authentication Terminal Root Certificate (AT-Root) for eID [TR-03110-2]."
                },
                {
                    "Name": "SEC_TA_IS_ROOT",
                    "Value": "6",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Inspection System Root Certificate (IS-Root) for MRTD [TR-03110-2]."
                },
                {
                    "Name": "SEC_CA1",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Chip Authentication v1 (CA1) for MRTD [TR-03110-1]."
                },
                {
                    "Name": "SEC_CA2",
                    "Value": "8",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Chip Authentication v2 (CA2) group key for eID [TR-03110-2]."
                },
                {
                    "Name": "SEC_CA2_PRIVILEGED",
                    "Value": "9",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Chip-specific CA2 key for Privileged Terminals eID [TR-03110-3]."
                },
                {
                    "Name": "SEC_CA3",
                    "Value": "10",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Chip Authentication v3 (CA3) group key for eID [TR-03110-2]."
                },
                {
                    "Name": "SEC_CA3_PSA",
                    "Value": "11",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Chip-specific CA3 key for Pseudonymous Secure Authentication (PSA) eID."
                },
                {
                    "Name": "SEC_TA_DV",
                    "Value": "12",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Output: Document Verify certificate received during EAC [TR-03110-3]."
                },
                {
                    "Name": "SEC_TA_TERMINAL",
                    "Value": "13",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Output: Certificate received from individual terminals [TR-03110-3]."
                },
                {
                    "Name": "SEC_TA_AT_LINKED",
                    "Value": "14",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Output: Linked TA certificate for rollover in eID [TR-03110-3]."
                },
                {
                    "Name": "SEC_TA_IS_LINKED",
                    "Value": "15",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Output: Linked TA certificate for rollover in MRTD [TR-03110-3]."
                },
                {
                    "Name": "SEC_KENC",
                    "Value": "32",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Encryption Key for SCP03 [GP Amd D] and SCP04 [GP Amd K]."
                },
                {
                    "Name": "SEC_KMAC",
                    "Value": "33",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "MAC Key for SCP03 [GP Amd D] and SCP04 [GP Amd K]."
                }
            ],
            "used_in": [
                "CSPSecureChannelSupport",
                "CSPSecureChannelAlgorithms"
            ]
        },
        "CSPSystemAttestationType": {
            "id": "CSPSystemAttestationType",
            "caption": "ASN 6-15: Attestations: ASN.1 Definition for CSPSystemAttestationType",
            "table": [
                {
                    "Name": "ATTESTATION_PLATFORM",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Attestation of the SE Platform the CSP is operated on."
                },
                {
                    "Name": "ATTESTATION_CONFIG",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Attestation of the configuration of this CSP Instance."
                }
            ],
            "used_in": [
                "CSPSystemAttestation",
                "CSPSignedPlatformData",
                "CSPSignedConfigData"
            ]
        },
        "CSPResourceAttestationType": {
            "id": "CSPResourceAttestationType",
            "caption": "ASN 6-16: Attestations: ASN.1 Definition for CSPResourceAttestationType",
            "table": [
                {
                    "Name": "ATTESTATION_DATA",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Attestation of external data with public key, counter or timer."
                },
                {
                    "Name": "ATTESTATION_KEY_POP",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Attestation of public key with proof of possession for the private key."
                },
                {
                    "Name": "ATTESTATION_KEY_GENERATION",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Generate a new key pair and returns a PoP attestation."
                }
            ],
            "used_in": [
                "CSPResourceAttestation",
                "CSPAttestationSupport",
                "CSPSignedData",
                "CSPPopData"
            ]
        },
        "CSPKeyType": {
            "id": "CSPKeyType",
            "caption": "ASN 6-24: Key: ASN.1 Definition for CSPKeyType",
            "table": [
                {
                    "Name": "KEY_AES",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Symmetric key used with Advanced Encryption Standard (AES)."
                },
                {
                    "Name": "KEY_HMAC",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Symmetric key used to create HMAC-based signatures."
                },
                {
                    "Name": "KEY_ECC_PUBLIC",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Public key used for Elliptic Curve Cryptography (ECC)."
                },
                {
                    "Name": "KEY_ECC_PRIVATE",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Private key used for Elliptic Curve Cryptography (ECC)."
                },
                {
                    "Name": "KEY_RSA_PUBLIC",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Public key for Rivest-Shamir-Adleman (RSA) algorithms."
                },
                {
                    "Name": "KEY_RSA_PRIVATE",
                    "Value": "6",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Private key for Rivest-Shamir-Adleman (RSA) algorithms."
                },
                {
                    "Name": "MASTER_SECRET",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Secret generated within the CSP, used for key derivation."
                },
                {
                    "Name": "DERIVED_SECRET",
                    "Value": "8",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Secret result from key derivation, used for further key derivation."
                },
                {
                    "Name": "KEY_SHARED_SECRET",
                    "Value": "9",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Secret from key agreement, used for key derivation."
                }
            ],
            "used_in": [
                "CSPKey"
            ]
        },
        "CSPKeySize": {
            "id": "CSPKeySize",
            "caption": "ASN 6-25: Key: ASN.1 Definition for CSPKeySize",
            "table": [
                {
                    "Name": "KEY_AES_128",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_AES 128 bit."
                },
                {
                    "Name": "KEY_AES_256",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_AES 256 bit."
                },
                {
                    "Name": "KEY_AES_2_128",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_AES 2x128 bit for CIPHER_AES_XTS."
                },
                {
                    "Name": "KEY_AES_2_256",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_AES 2x256 bit for CIPHER_AES_XTS."
                },
                {
                    "Name": "KEY_HMAC_256",
                    "Value": "10",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_HMAC 256 bit."
                },
                {
                    "Name": "KEY_HMAC_384",
                    "Value": "11",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_HMAC 384 bit."
                },
                {
                    "Name": "KEY_HMAC_512",
                    "Value": "12",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_HMAC 512 bit."
                },
                {
                    "Name": "KEY_ECC_256",
                    "Value": "16",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_ECC_PUBLIC and KEY_ECC_PRIVATE 256 bit."
                },
                {
                    "Name": "KEY_ECC_384",
                    "Value": "17",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_ECC_PUBLIC and KEY_ECC_PRIVATE 384 bit."
                },
                {
                    "Name": "KEY_ECC_512",
                    "Value": "18",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_ECC_PUBLIC and KEY_ECC_PRIVATE 512 bit."
                },
                {
                    "Name": "KEY_ECC_521",
                    "Value": "19",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_ECC_PUBLIC and KEY_ECC_PRIVATE 521 bit."
                },
                {
                    "Name": "KEY_RSA_2048",
                    "Value": "26",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_RSA_PUBLIC and KEY_RSA_PRIVATE 2048 bit."
                },
                {
                    "Name": "KEY_RSA_3072",
                    "Value": "27",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_RSA_PUBLIC and KEY_RSA_PRIVATE 3072 bit."
                },
                {
                    "Name": "KEY_RSA_4096",
                    "Value": "28",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_RSA_* 4096 bit; do not generate, only for import recommended."
                },
                {
                    "Name": "KEY_SECRET_128",
                    "Value": "32",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_MASTER_SECRET, KEY_DERIVED_SECRET and KEY_SHARED_SECRET 128 bit."
                },
                {
                    "Name": "KEY_SECRET_256",
                    "Value": "33",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_MASTER_SECRET, KEY_DERIVED_SECRET and KEY_SHARED_SECRET 256 bit."
                },
                {
                    "Name": "KEY_SECRET_384",
                    "Value": "34",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_MASTER_SECRET, KEY_DERIVED_SECRET and KEY_SHARED_SECRET 384 bit."
                },
                {
                    "Name": "KEY_SECRET_512",
                    "Value": "35",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_MASTER_SECRET, KEY_DERIVED_SECRET and KEY_SHARED_SECRET 512 bit."
                },
                {
                    "Name": "KEY_SECRET_576",
                    "Value": "36",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "KEY_MASTER_SECRET and KEY_DERIVED_SECRET."
                }
            ],
            "used_in": [
                "CSPKeySupport",
                "CSPKey",
                "CSPKeySizeOrCurve"
            ]
        },
        "CSPCurve": {
            "id": "CSPCurve",
            "caption": "ASN 6-26: Key: ASN.1 Definition for CSPCurve",
            "table": [
                {
                    "Name": "CURVE_BRAINPOOL_P256_R1",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Brainpool P256 r1 [RFC 5639]."
                },
                {
                    "Name": "CURVE_BRAINPOOL_P384_R1",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Brainpool P384 r1 [RFC 5639]."
                },
                {
                    "Name": "CURVE_BRAINPOOL_P512_R1",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Brainpool P512 r1 [RFC 5639]."
                },
                {
                    "Name": "CURVE_SEC_P256_R1",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "NIST's P-256 curve [SP800-186]."
                },
                {
                    "Name": "CURVE_SEC_P384_R1",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "NIST's P-384 curve [SP800-186]."
                },
                {
                    "Name": "CURVE_SEC_P521_R1",
                    "Value": "6",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "NIST's P-521 curve [SP800-186]."
                },
                {
                    "Name": "CURVE_X25519",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "256-bit, only key agreement [RFC 7748]."
                }
            ],
            "used_in": [
                "CSPKeySupport",
                "CSPKey",
                "CSPKeySizeOrCurve"
            ]
        },
        "CSPKeyDerivationAlgorithm": {
            "id": "CSPKeyDerivationAlgorithm",
            "caption": "ASN 6-29: Key: ASN.1 Definition for CSPKeyDerivationAlgorithm",
            "table": [
                {
                    "Name": "KDF_AES_CMAC",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Two-step key derivation [SP800-56C]."
                },
                {
                    "Name": "KDF_ECC",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "ECC private key derivation from a secret [TR-03111]."
                },
                {
                    "Name": "KDF_HKDF",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "HMAC-based key derivation [RFC 5869]."
                },
                {
                    "Name": "KDF_PBKDF2",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Password-based key derivation [PKCS #5]."
                }
            ],
            "used_in": [
                "CSPKeySupport",
                "CSPKeyDerivationAlgorithms"
            ]
        },
        "CSPKeyAgreementScheme": {
            "id": "CSPKeyAgreementScheme",
            "caption": "ASN 6-30: Key: ASN.1 Definition for CSPKeyAgreementScheme",
            "table": [
                {
                    "Name": "KAS_ECKA_DH",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "ECC Diffie-Hellman key agreement."
                },
                {
                    "Name": "KAS_ECKA_EG",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "ECC ElGamal key agreement."
                }
            ],
            "used_in": [
                "CSPAlgorithms",
                "CSPKeySupport"
            ]
        },
        "CSPCertificateType": {
            "id": "CSPCertificateType",
            "caption": "ASN 6-33: Certificate: ASN.1 Definition for CSPCertificateType",
            "table": [
                {
                    "Name": "CERT_CVC",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Card Verifiable Certificate (CVC) according to [TR-03110-3]."
                },
                {
                    "Name": "CERT_X509",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "X.509 Certificate according to [ITU-T X.509]."
                }
            ],
            "used_in": [
                "CSPCertificateSupport",
                "CSPCertificate"
            ]
        },
        "CSPPasswordType": {
            "id": "CSPPasswordType",
            "caption": "ASN 6-36: Password: ASN.1 Definition for CSPPasswordType",
            "table": [
                {
                    "Name": "PWD_ANY",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "No rules apply on passwords."
                },
                {
                    "Name": "PWD_NUMERIC",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Only ASCII numbers (e.g., PIN or PUK)."
                },
                {
                    "Name": "PWD_ALPHANUMERIC",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "ASCII alphanumeric (0-9, a-z, A-Z)."
                },
                {
                    "Name": "PWD_UTF8",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "UTF-8 charset."
                },
                {
                    "Name": "PWD_STRONG",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "UTF-8 charset, min. 1 uppercase, 1 lowercase, 1 number, 1 special."
                }
            ],
            "used_in": [
                "CSPPasswordSupport",
                "CSPPassword"
            ]
        },
        "CSPCounterMode": {
            "id": "CSPCounterMode",
            "caption": "ASN 6-39: Counter: ASN.1 Definition for CSPCounterMode",
            "table": [
                {
                    "Name": "COUNTER_MODE_OFF",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Counter functionality is disabled or not available."
                },
                {
                    "Name": "COUNTER_MODE_IGNORE",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Ignore counters configured if not supported by the platform."
                },
                {
                    "Name": "COUNTER_MODE_STRICT",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Stop operation if a configured counter is not supported."
                }
            ],
            "used_in": [
                "CSPCounterSupport",
                "CSPCounterSettings"
            ]
        },
        "CSPCounterType": {
            "id": "CSPCounterType",
            "caption": "ASN 6-40: Counter: ASN.1 Definition for CSPCounterType",
            "table": [
                {
                    "Name": "COUNT_MANUAL",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Manual counter invoked by the Client Application."
                },
                {
                    "Name": "COUNT_USAGE_PER_BLOCK",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "usage counter counting each computation, including each cipher block."
                },
                {
                    "Name": "COUNT_USAGE_COMPLETIONS",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "usage counter counting complete processes (e.g., only doFinal calls)."
                },
                {
                    "Name": "COUNT_USAGE_SUCCESS_ONLY",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Usage counter counting only successful processes (excluding updates)."
                },
                {
                    "Name": "COUNT_USAGE_FAILURE_ONLY",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Usage counter counting only failed processes (excluding updates)."
                },
                {
                    "Name": "COUNT_AUTH_USAGE",
                    "Value": "6",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Password authentication timeout realized as usage counter."
                },
                {
                    "Name": "COUNT_TRANSPORT_USAGE",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Transport counter (e.g., OTP) for passwords in transport."
                }
            ],
            "used_in": [
                "CSPCounterSupport"
            ]
        },
        "CSPCounterCapacity": {
            "id": "CSPCounterCapacity",
            "caption": "ASN 6-43: Counter: ASN.1 Definition for CSPCounterCapacity",
            "table": [
                {
                    "Name": "COUNTER_TINY",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Tiny: 1-byte counter supporting 10,000 increments."
                },
                {
                    "Name": "COUNTER_SMALL",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Small: 2-byte counter supporting 10,000 increments."
                },
                {
                    "Name": "COUNTER_MEDIUM",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Medium: 4-byte counter supporting 100,000 increments."
                },
                {
                    "Name": "COUNTER_LARGE",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Large: 4-byte counter supporting 5,000,000 increments."
                }
            ],
            "used_in": [
                "CSPCounterSupport",
                "CSPCounter"
            ]
        },
        "CSPTimeMode": {
            "id": "CSPTimeMode",
            "caption": "ASN 6-46: Time: ASN.1 Definition for CSPTimeMode",
            "table": [
                {
                    "Name": "TIME_MODE_OFF",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Time functionality is disabled or not available."
                },
                {
                    "Name": "TIME_MODE_IGNORE",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Ignore time-related configurations if time is not supported."
                },
                {
                    "Name": "TIME_MODE_STRICT",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Stop operation if time is not synchronized."
                }
            ],
            "used_in": [
                "CSPTimeSupport",
                "CSPTimeSettings"
            ]
        },
        "CSPTimerType": {
            "id": "CSPTimerType",
            "caption": "ASN 6-48: Time: ASN.1 Definition for CSPTimerType",
            "table": [
                {
                    "Name": "TIMER_MANUAL_DATE",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Manual timer invoked by the Client Application."
                },
                {
                    "Name": "TIMER_MANUAL_PERIOD",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Manual timer invoked by the Client Application."
                },
                {
                    "Name": "TIMER_VALIDITY_PERIOD",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Validity period used to compute (and refresh) the validity date."
                },
                {
                    "Name": "TIMER_VALIDITY_DATE",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Validity date as specific Unix timestamp."
                },
                {
                    "Name": "TIMER_VALIDITY_CERTIFICATE",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Validity date extracted from certificates."
                },
                {
                    "Name": "TIMER_AUTH_TIMEOUT",
                    "Value": "6",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Timeout for authenticated passwords."
                },
                {
                    "Name": "TIMER_SECURITY_TIMEOUT",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Timeout for secure channel service."
                }
            ],
            "used_in": [
                "CSPTimeSupport"
            ]
        },
        "CSPTimeoutType": {
            "id": "CSPTimeoutType",
            "caption": "ASN 6-53: Time: ASN.1 Definition for CSPTimeoutType",
            "table": [
                {
                    "Name": "TIMEOUT_OFF",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Timeout functionality is disabled and/or not available."
                },
                {
                    "Name": "TIMEOUT_HARD",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Fixed timeout after which the authenticated state is invalidated."
                },
                {
                    "Name": "TIMEOUT_SOFT",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Dynamic timeout that is refreshed when using the resource."
                }
            ],
            "used_in": [
                "CSPTimeSupport",
                "CSPTimeout"
            ]
        },
        "CSPAuditMode": {
            "id": "CSPAuditMode",
            "caption": "ASN 6-57: Audit: ASN.1 Definition for CSPAuditMode",
            "table": [
                {
                    "Name": "AUDIT_MODE_OFF",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Audit event logging is disabled or not available."
                },
                {
                    "Name": "AUDIT_MODE_OVERWRITE",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "events that are not fetched will be overwritte if audit queue is full."
                },
                {
                    "Name": "AUDIT_MODE_STRICT",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "CSP will throw an exception if audit event queue is full."
                }
            ],
            "used_in": [
                "CSPAuditSupport",
                "CSPAuditSettings"
            ]
        },
        "CSPSystemEvent": {
            "id": "CSPSystemEvent",
            "caption": "ASN 6-58: Audit: ASN.1 Definition for CSPSystemEvent",
            "table": [
                {
                    "Name": "EVENT_CSP_START",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Startup of the CSP (0x0001)."
                },
                {
                    "Name": "EVENT_CSP_UPDATE_STARTED",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Start of a CSP software update (0x0002)."
                },
                {
                    "Name": "EVENT_CSP_UPDATE_FINISHED",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "CSP software update is finished (0x0003)."
                },
                {
                    "Name": "EVENT_CSP_CONFIG_UPDATED",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The CSP configuration is modified (0x0004)."
                },
                {
                    "Name": "EVENT_CSP_ERROR",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "An error occurred that was not yet covered by another event (0x0005)."
                },
                {
                    "Name": "EVENT_CSP_TIME_SET",
                    "Value": "176",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "A new reference time is set (0x00B0)."
                }
            ],
            "used_in": [
                "CSPAuditSupport",
                "CSPAuditSettings"
            ]
        },
        "CSPResourceEvent": {
            "id": "CSPResourceEvent",
            "caption": "ASN 6-59: Audit: ASN.1 Definition for CSPResourceEvent",
            "table": [
                {
                    "Name": "EVENT_RESOURCE_CLEARED",
                    "Value": "4096",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Resource cleared successfully (0x1000)."
                },
                {
                    "Name": "EVENT_RESOURCE_VALUE_SET",
                    "Value": "4097",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Resource modified (0x1001)."
                },
                {
                    "Name": "EVENT_CIPHER_ENCRYPTED",
                    "Value": "4112",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Data encrypted successfully (0x1010)."
                },
                {
                    "Name": "EVENT_CIPHER_DECRYPTED",
                    "Value": "4113",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Data decrypted successfully (0x1011)."
                },
                {
                    "Name": "EVENT_SIGNATURE_CREATED",
                    "Value": "4128",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Signature created successfully (0x1020)."
                },
                {
                    "Name": "EVENT_SIGNATURE_VERIFIED",
                    "Value": "4129",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Signature verified successfully (0x1021)."
                },
                {
                    "Name": "EVENT_SIGNATURE_VERIFICATION_FAILED",
                    "Value": "4130",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Signature verification failed (0x1022)."
                },
                {
                    "Name": "EVENT_SECURE_CHANNEL_ESTABLISHED",
                    "Value": "4160",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Secure messaging successfully established (0x1040)."
                },
                {
                    "Name": "EVENT_SECURE_CHANNEL_AUTHENTICATION_FAILED",
                    "Value": "4161",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Authentication for secure messaging failed (0x1041)."
                },
                {
                    "Name": "EVENT_KEY_GENERATED",
                    "Value": "4208",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Key successfully generated (0x1070)."
                },
                {
                    "Name": "EVENT_KEY_DERIVED",
                    "Value": "4209",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Key derived successfully (0x1071)."
                },
                {
                    "Name": "EVENT_KEY_SHARED_SECRET_COMPUTED",
                    "Value": "4210",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Successful key agreement (0x1072)."
                },
                {
                    "Name": "EVENT_PUBLIC_KEY_IMPORTED",
                    "Value": "4211",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Successfully imported a new public key value (0x1073)."
                },
                {
                    "Name": "EVENT_CERTIFICATE_IMPORTED",
                    "Value": "4224",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Successfully imported a new certificate (0x1080)."
                },
                {
                    "Name": "EVENT_CERTIFICATE_EXPORTED",
                    "Value": "4225",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Successfully exported a certificate (0x1081)."
                },
                {
                    "Name": "EVENT_PASSWORD_UPDATED",
                    "Value": "4240",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Password changed successfully (0x1090)."
                },
                {
                    "Name": "EVENT_PASSWORD_UPDATE_FAILED",
                    "Value": "4241",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Changing a password failed (0x1091)."
                },
                {
                    "Name": "EVENT_PASSWORD_AUTHENTICATED",
                    "Value": "4242",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Password verified successfully (0x1092)."
                },
                {
                    "Name": "EVENT_PASSWORD_CHECK_FAILED",
                    "Value": "4243",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Password mismatch (0x1093)."
                },
                {
                    "Name": "EVENT_PASSWORD_BLOCKED",
                    "Value": "4244",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Password is blocked due to too many incorrect password attempts (0x1094)"
                },
                {
                    "Name": "EVENT_PASSWORD_UNBLOCKED",
                    "Value": "4245",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "A blocked password was unblocked (0x1095)."
                },
                {
                    "Name": "EVENT_COUNTER_EXHAUSTED",
                    "Value": "4256",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Resource counter exhausted (0x10B0)."
                },
                {
                    "Name": "EVENT_TIMER_EXPIRED",
                    "Value": "4272",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Resource validity date expired (0x10C0)."
                },
                {
                    "Name": "EVENT_OFFLOAD_IMPORTED",
                    "Value": "4304",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Resource imported for offloading (0x10D0)."
                },
                {
                    "Name": "EVENT_OFFLOAD_EXPORTED",
                    "Value": "4305",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Resource exported for offloading (0x10D1)."
                }
            ],
            "used_in": [
                "CSPConfigureResource",
                "CSPResource",
                "CSPAuditSupport"
            ]
        },
        "CSPFieldMode": {
            "id": "CSPFieldMode",
            "caption": "ASN 6-72: Signature: ASN.1 Definition for CSPFieldMode",
            "table": [
                {
                    "Name": "FIELD_MODE_OFF",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Fields are disabled or not available."
                },
                {
                    "Name": "FIELD_MODE_IGNORE",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Ignore field configurations that are not supported by the platform."
                },
                {
                    "Name": "FIELD_MODE_STRICT",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Stop operation if a field configured is not supported."
                }
            ],
            "used_in": [
                "CSPFieldSupport",
                "CSPFieldSettings"
            ]
        },
        "CSPFieldType": {
            "id": "CSPFieldType",
            "caption": "ASN 6-74: Signature: ASN.1 Definition for CSPFieldType",
            "table": [
                {
                    "Name": "FIELD_SYSTEM_TIME",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Estimated system time as Unix timestamp in seconds, 8 bytes."
                },
                {
                    "Name": "FIELD_TIME_SINCE_BOOT",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The time since boot in seconds, 4 bytes."
                },
                {
                    "Name": "FIELD_REFERENCE_TIME",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The reference time set by CSP Admin or CSP Client."
                },
                {
                    "Name": "FIELD_USAGE_COUNTER",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The The value of a resource usage counter."
                },
                {
                    "Name": "FIELD_CSP_CONFIG_VERSION",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The version of the CSP Configuration set by the CSP Admin."
                },
                {
                    "Name": "FIELD_CSP_PROTOCOL_VERSION",
                    "Value": "6",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The version of the CSP Protocol of the platform."
                },
                {
                    "Name": "FIELD_CSP_ELF_VERSION",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The version of the CSP ELF."
                },
                {
                    "Name": "FIELD_RESOURCE_STATE",
                    "Value": "8",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The resource state."
                },
                {
                    "Name": "FIELD_PUBKEY",
                    "Value": "9",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The value of a public key."
                },
                {
                    "Name": "FIELD_MANUAL_COUNTER",
                    "Value": "10",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The value of a manual counter."
                },
                {
                    "Name": "FIELD_MANUAL_COUNTER_LIMIT",
                    "Value": "11",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The limit set to a manual counter."
                },
                {
                    "Name": "FIELD_MANUAL_TIMER",
                    "Value": "12",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The value of a manual timer."
                },
                {
                    "Name": "FIELD_MANUAL_TIMER_LIMIT",
                    "Value": "13",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The limit of a manual timer."
                }
            ],
            "used_in": [
                "CSPFieldSupport",
                "CSPField",
                "CSPFieldValue"
            ]
        },
        "CSPFieldSource": {
            "id": "CSPFieldSource",
            "caption": "ASN 6-75: Signature: ASN.1 Definition for CSPFieldSource",
            "table": [
                {
                    "Name": "DEFAULT_SOURCE",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "System data or if a resource is required the signing key resource."
                },
                {
                    "Name": "EVENT_SOURCE",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The resource that triggered the audit event."
                }
            ],
            "used_in": [
                "CSPFieldSupport",
                "CSPSource"
            ]
        },
        "CSPPolicyMode": {
            "id": "CSPPolicyMode",
            "caption": "ASN 6-79: Access: ASN.1 Definition for CSPPolicyMode",
            "table": [
                {
                    "Name": "POLICY_MODE_OFF",
                    "Value": "0",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Policy evaluation is disabled or not available."
                },
                {
                    "Name": "POLICY_MODE_IGNORE_UNSUPPORTED",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Ignore policy configurations that are not supported by the platform."
                },
                {
                    "Name": "POLICY_MODE_STRICT",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Stop operation if a configured policy is not supported."
                }
            ],
            "used_in": [
                "CSPPolicySupport",
                "CSPPolicySettings"
            ]
        },
        "CSPPolicyType": {
            "id": "CSPPolicyType",
            "caption": "ASN 6-81: Access: ASN.1 Definition for CSPPolicyType",
            "table": [
                {
                    "Name": "POLICY_KEYPAIR",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The public key provided must be associated to the private key."
                },
                {
                    "Name": "POLICY_SECCHANNEL_ESTABLISHED",
                    "Value": "2",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "An associated secure channel must be fully established."
                },
                {
                    "Name": "POLICY_PASSWORD",
                    "Value": "3",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "An associated password must be authenticated."
                },
                {
                    "Name": "POLICY_UNBLOCK_PASSWORD",
                    "Value": "4",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The PUK used to unblock a password must be associated to the password."
                },
                {
                    "Name": "POLICY_PRE_BLOCKED",
                    "Value": "5",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "A password with tryCounter=1 requires an associated CAN authenticated."
                },
                {
                    "Name": "POLICY_TA2_ACCESS_FLAG",
                    "Value": "6",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "A specific access flag must be present in sec channel TA2 certificates."
                },
                {
                    "Name": "POLICY_ASSOCIATION",
                    "Value": "7",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "The second resource involved must be associated to the main resource."
                }
            ],
            "used_in": [
                "CSPPolicySupport",
                "CSPPolicy"
            ]
        }
    },
    "INTEGER": {
        "CSPProtocolVersion": {
            "id": "CSPProtocolVersion",
            "caption": "ASN 5-3: Core: ASN.1 Definition for CSPProtocolVersion",
            "table": [
                {
                    "Name": "protocolVersion1",
                    "Value": "1",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "API level for the CSP Protocol used."
                }
            ],
            "used_in": [
                "CSPEnforce",
                "CSPRegisterClient",
                "CSPUnregisterClient",
                "CSPCreateResource",
                "CSPDestroyResource",
                "CSPConfigureResource",
                "CSPSetup",
                "CSPActivate",
                "CSPDeactivate",
                "CSPGetConfiguration",
                "CSPGetConfigurationResponse",
                "CSPSetValue",
                "CSPProcessSecurity",
                "CSPSign",
                "CSPVerifySignature",
                "CSPEncrypt",
                "CSPDecrypt",
                "CSPResourceAttestation",
                "CSPClearResource",
                "CSPSystemAttestation",
                "CSPGenerateKey",
                "CSPComputePublicKey",
                "CSPDeriveKey",
                "CSPSetTime",
                "CSPPlatform",
                "CSPSignedPlatformData",
                "CSPSignedConfigData",
                "CSPSignedData",
                "CSPSignedPoPData",
                "CSPEventDataUpdateCSP",
                "CSPEventDataUpdateCSP"
            ]
        },
        "CSPConfigVersion": {
            "id": "CSPConfigVersion",
            "caption": "ASN 5-6: Core: ASN.1 Definition for CSPConfigVersion",
            "table": [
                {
                    "Name": "CSPConfigVersion",
                    "Value": "0..32767",
                    "Size": "1..2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Version of the configuration of this CSP Instance."
                }
            ],
            "used_in": [
                "CSPActivate",
                "CSPSettings",
                "CSPSignedConfigData",
                "CSPEventDataUpdateConfig",
                "CSPEventDataUpdateConfig"
            ]
        },
        "CSPResourceId": {
            "id": "CSPResourceId",
            "caption": "ASN 5-18: Resource: ASN.1 Definition for CSPResourceId",
            "table": [
                {
                    "Name": "CSPResourceId",
                    "Value": "0..32767",
                    "Size": "1..2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "Unique identifier of a Resource."
                }
            ],
            "used_in": [
                "CSPDestroyResource",
                "CSPConfigureResource",
                "CSPSetValue",
                "CSPSetValue",
                "CSPSign",
                "CSPVerifySignature",
                "CSPEncrypt",
                "CSPDecrypt",
                "CSPResourceAttestation",
                "CSPClearResource",
                "CSPGenerateKey",
                "CSPComputePublicKey",
                "CSPComputePublicKey",
                "CSPDeriveKey",
                "CSPDeriveKey",
                "CSPSettings",
                "CSPResource",
                "CSPClient",
                "CSPTimeSettings",
                "CSPAuditSettings",
                "CSPEventDataGeneralError",
                "CSPEventDataResource",
                "CSPEventDataKeyDerivation",
                "CSPEventDataKeyDerivation",
                "CSPEventDataKeyAgreement",
                "CSPEventDataKeyAgreement",
                "CSPEventDataKeyAgreement",
                "CSPEventDataPasswordFailure",
                "CSPSource",
                "CSPFieldValue",
                "CSPPolicy"
            ]
        }
    },
    "CHOICE": {
        "CSPAdminCommandChoice": {
            "id": "CSPAdminCommandChoice",
            "caption": "ASN 7-1bb: CSP Protocol: ASN.1 Definition for CSPAdminCommandChoice",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPAdminCommandChoice",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "A0",
                    "Size": "5..n",
                    "type_outer": null,
                    "type_inner": "CSPEnforce",
                    "Description": "\"enforce\": Detect features and/or algorithms supported by this platform.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A1",
                    "Size": "9..n",
                    "type_outer": null,
                    "type_inner": "CSPRegisterClient",
                    "Description": "\"registerApplication\": Register the AID of a Client Application for use with this CSP Instance.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A2",
                    "Size": "8..23",
                    "type_outer": null,
                    "type_inner": "CSPUnregisterClient",
                    "Description": "\"unregisterApplication\": Unregister a Client Application from this CSP Instance.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A3",
                    "Size": "19..342",
                    "type_outer": null,
                    "type_inner": "CSPCreateResource",
                    "Description": "\"createResource\": Create a key, certificate, password, counter or timer as resource.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A4",
                    "Size": "8..9",
                    "type_outer": null,
                    "type_inner": "CSPDestroyResource",
                    "Description": "\"destroyResource\": Destroy a resource and free memory.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A5",
                    "Size": "8..315",
                    "type_outer": null,
                    "type_inner": "CSPConfigureResource",
                    "Description": "\"configureResource\": Change the configuration of a resource.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A6",
                    "Size": "5..n",
                    "type_outer": null,
                    "type_inner": "CSPSetup",
                    "Description": "\"setup\": Change the general settings of the CSP Instance.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A7",
                    "Size": "5..9",
                    "type_outer": null,
                    "type_inner": "CSPActivate",
                    "Description": "\"activate\": Activate this CSP Instance for operational use.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A8",
                    "Size": "5",
                    "type_outer": null,
                    "type_inner": "CSPDeactivate",
                    "Description": "\"deactivate\": Deactivate this CSP Instance, thus Client Applications cannot use it.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A9",
                    "Size": "5",
                    "type_outer": null,
                    "type_inner": "CSPGetConfiguration",
                    "Description": "\"getConfig\": Retrieve the entire configuration settings of this CSP Instance.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "AA",
                    "Size": "13..65578",
                    "type_outer": null,
                    "type_inner": "CSPSetValue",
                    "Description": "\"setValue\": Set the value of a resource (e.g., key value, password, certificate).",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "AB",
                    "Size": "8..9",
                    "type_outer": null,
                    "type_inner": "CSPClearResource",
                    "Description": "\"clearResource\": Securely wipe the value of a resource.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "AC",
                    "Size": "8..526",
                    "type_outer": null,
                    "type_inner": "CSPSystemAttestation",
                    "Description": "\"systemAttestation\":    Compute an SE Platform attestation or CSP Config attestation.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "AD",
                    "Size": "8..9",
                    "type_outer": null,
                    "type_inner": "CSPGenerateKey",
                    "Description": "\"generateKey\": Generate a symmetric or private key value with random data.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "AE",
                    "Size": "11..13",
                    "type_outer": null,
                    "type_inner": "CSPComputePublicKey",
                    "Description": "\"computePublicKey\": Compute the public part of a private key value.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "AF",
                    "Size": "29..531",
                    "type_outer": null,
                    "type_inner": "CSPDeriveKey",
                    "Description": "\"deriveKey\": Derive a key from a source key and optional input data.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "B0",
                    "Size": "15..65559",
                    "type_outer": null,
                    "type_inner": "CSPSetTime",
                    "Description": "\"settime\": Set the reference time that is used to estimate the system time.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": [
                "CSPAdminCommand"
            ]
        },
        "CSPClientCommandChoice": {
            "id": "CSPClientCommandChoice",
            "caption": "ASN 7-14ba: CSP Protocol: ASN.1 Definition for CSPClientCommandChoice",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPClientCommandChoice",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "AC",
                    "Size": "8..526",
                    "type_outer": null,
                    "type_inner": "CSPSystemAttestation",
                    "Description": "\"systemAttestation\": Compute an SE platform attestation or a CSP Config attestation.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "B1",
                    "Size": "8..32778",
                    "type_outer": null,
                    "type_inner": "CSPProcessSecurity",
                    "Description": "\"processAuthentication\": Process secure channel authentication defined via authProtocol.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "B2",
                    "Size": "5..98324",
                    "type_outer": null,
                    "type_inner": "CSPRequiresAuthentication",
                    "Description": "\"requiresAuthentication\": Command structures that require Client Authentication.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": [
                "CSPClientCommand"
            ]
        },
        "CSPRequiresAuthentication": {
            "id": "CSPRequiresAuthentication",
            "caption": "ASN 7-14bb: CSP Protocol: ASN.1 Definition for CSPRequiresAuthentication",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPRequiresAuthentication",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "A0",
                    "Size": "5",
                    "type_outer": null,
                    "type_inner": "CSPGetConfiguration",
                    "Description": "\"getConfig\":    Retrieve the entire configuration settings of this CSP Instance.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A1",
                    "Size": "8..9",
                    "type_outer": null,
                    "type_inner": "CSPClearResource",
                    "Description": "\"clearResource\":    Securely wipe the value of a resource.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A2",
                    "Size": "8..9",
                    "type_outer": null,
                    "type_inner": "CSPGenerateKey",
                    "Description": "\"generateKey\":    Generate a symmetric or private key value with random data.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A3",
                    "Size": "11..13",
                    "type_outer": null,
                    "type_inner": "CSPComputePublicKey",
                    "Description": "\"computePublicKey\":    Compute the public part of a private key value.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A4",
                    "Size": "29..531",
                    "type_outer": null,
                    "type_inner": "CSPDeriveKey",
                    "Description": "\"deriveKey\":    Derive a key from a source key and optional input data.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A5",
                    "Size": "15..65559",
                    "type_outer": null,
                    "type_inner": "CSPSetTime",
                    "Description": "\"settime\": Set the reference time that is used to estimate the system time.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A6",
                    "Size": "10..32782",
                    "type_outer": null,
                    "type_inner": "CSPSign",
                    "Description": "\"sign\":    Create a signature.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A7",
                    "Size": "76..98324",
                    "type_outer": null,
                    "type_inner": "CSPVerifySignature",
                    "Description": "\"verifySignature\":    Create a signature.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A8",
                    "Size": "10..32800",
                    "type_outer": null,
                    "type_inner": "CSPEncrypt",
                    "Description": "\"encrypt\":    Encrypt data.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A9",
                    "Size": "10..32800",
                    "type_outer": null,
                    "type_inner": "CSPDecrypt",
                    "Description": "\"decrypt\":    Decrypt data.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "AA",
                    "Size": "29..530",
                    "type_outer": null,
                    "type_inner": "CSPResourceAttestation",
                    "Description": "\"resourceAttestation\":    Compute a resource attestation.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": [
                "CSPClientCommandChoice"
            ]
        },
        "CSPResourceAttestationResponse": {
            "id": "CSPResourceAttestationResponse",
            "caption": "ASN 7-26: Attestations: ASN.1 Definition for CSPResourceAttestationResponse",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPResourceAttestationResponse",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "A0",
                    "Size": "103..131144",
                    "type_outer": null,
                    "type_inner": "CSPDataAttestation",
                    "Description": "\"dataAttestation\":     Conditional: Response of a data attestation.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A1",
                    "Size": "252..229483",
                    "type_outer": null,
                    "type_inner": "CSPKeyPoPAttestation",
                    "Description": "\"keyAttestation\":     Conditional: Response of the key attestation.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": []
        },
        "CSPSystemAttestationResponse": {
            "id": "CSPSystemAttestationResponse",
            "caption": "ASN 7-29: Attestations: ASN.1 Definition for CSPSystemAttestationResponse",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPSystemAttestationResponse",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "A0",
                    "Size": "2227..n",
                    "type_outer": null,
                    "type_inner": "CSPPlatformAttestation",
                    "Description": "\"platformAttestation\":     Conditional: Response of the CASD-based SE platform attestation.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A1",
                    "Size": "198..98476",
                    "type_outer": null,
                    "type_inner": "CSPConfigAttestation",
                    "Description": "\"configAttestation\":     Conditional: Response of the CSP-specific config attestation.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": []
        },
        "CSPResourceParams": {
            "id": "CSPResourceParams",
            "caption": "ASN 5-17b: Resource: ASN.1 Definition for CSPResourceParams",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPResourceParams",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "A0",
                    "Size": "8..14",
                    "type_outer": null,
                    "type_inner": "CSPKey",
                    "Description": "\"keyParams\":     Parameters specific to key resources.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A1",
                    "Size": "5",
                    "type_outer": null,
                    "type_inner": "CSPCertificate",
                    "Description": "\"certificateParams\":     Parameters specific to certificate resources.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A2",
                    "Size": "5..14",
                    "type_outer": null,
                    "type_inner": "CSPPassword",
                    "Description": "\"passwordParams\":     Parameters specific to password resources.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A3",
                    "Size": "2..11",
                    "type_outer": null,
                    "type_inner": "CSPCounter",
                    "Description": "\"counterParams\":     Parameters specific to manual counter resources.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A4",
                    "Size": "4..9",
                    "type_outer": null,
                    "type_inner": "CSPManualTimer",
                    "Description": "\"timerParams\":     Parameters specific to manual timer resources.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": [
                "CSPResource"
            ]
        },
        "CSPAlgorithms": {
            "id": "CSPAlgorithms",
            "caption": "ASN 5-23: Resource: ASN.1 Definition for CSPAlgorithms",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPAlgorithms",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "80",
                    "Size": "0",
                    "type_outer": null,
                    "type_inner": "NULL",
                    "Description": "\"noneAlgorithm\":     No algorithm configured.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A1",
                    "Size": "5..8",
                    "type_outer": null,
                    "type_inner": "CSPCipherAlgorithms",
                    "Description": "\"cipherAlgorithms\":     USAGE_CIPHER, USAGE_TRANSFORM, USAGE_CONFIDENTIAL.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A2",
                    "Size": "5..11",
                    "type_outer": null,
                    "type_inner": "CSPSignatureAlgorithms",
                    "Description": "\"signatureAlgorithms\":     USAGE_SIGNATURE, USAGE_AUDIT.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A3",
                    "Size": "5",
                    "type_outer": null,
                    "type_inner": "CSPSecureChannelAlgorithms",
                    "Description": "\"secChannelAlgorithms\":     USAGE_SECCHANNEL: secure channel authentication.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A4",
                    "Size": "9..37",
                    "type_outer": null,
                    "type_inner": "CSPAttestationAlgorithms",
                    "Description": "\"attestationAlgorithm\":     USAGE_ATTESTATION, USAGE_AUDIT.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A5",
                    "Size": "5..8",
                    "type_outer": null,
                    "type_inner": "CSPKeyDerivationAlgorithms",
                    "Description": "\"keyDerivationAlgorithm\":     USAGE_KEY: Key derivation algorithm.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "86",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "CSPKeyAgreementScheme",
                    "Description": "\"keyAgreementScheme\":     USAGE_KEY: Key agreement scheme.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": [
                "CSPConfigureResource",
                "CSPResource"
            ]
        },
        "CSPClientReference": {
            "id": "CSPClientReference",
            "caption": "ASN 5-25: Core: ASN.1 Definition for CSPClientReference",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPClientReference",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "80",
                    "Size": "1..2",
                    "type_outer": null,
                    "type_inner": "INTEGER",
                    "Description": "\"clientId\":     The identifier of the CSP Client to be de-registered.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "81",
                    "Size": "5..16",
                    "type_outer": null,
                    "type_inner": "CSPAID",
                    "Description": "\"aid\":     The AID of the Client Application that shall be de-registered.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": [
                "CSPUnregisterClient",
                "CSPAccessControl"
            ]
        },
        "CSPApplicationSD": {
            "id": "CSPApplicationSD",
            "caption": "ASN 5-26b: Core: ASN.1 Definition for CSPApplicationSD",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPApplicationSD",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "80",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "BOOLEAN",
                    "Description": "\"useCspSD\":     The Client Application uses same SD AID as the CSP Application.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "81",
                    "Size": "5..16",
                    "type_outer": null,
                    "type_inner": "CSPAID",
                    "Description": "\"applicationSDAID\":     The Client Application uses an other SD AID as the CSP Application.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": [
                "CSPClientApplication"
            ]
        },
        "CSPKeySizeOrCurve": {
            "id": "CSPKeySizeOrCurve",
            "caption": "ASN 6-27: Key: ASN.1 Definition for CSPKeySizeOrCurve",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPKeySizeOrCurve",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "80",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "CSPKeySize",
                    "Description": "\"size\":     The keySize in number of bits (not for ECC_*).",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "81",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "CSPCurve",
                    "Description": "\"curve\":     ECC curve relevant for keys of type ECC_*.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": [
                "CSPConfigAttestation",
                "CSPDataAttestation",
                "CSPKeyPoPAttestation",
                "CSPKeyPoPAttestation"
            ]
        },
        "CSPManualTimer": {
            "id": "CSPManualTimer",
            "caption": "ASN 6-54: Time: ASN.1 Definition for CSPManualTimer",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPManualTimer",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "80",
                    "Size": "8",
                    "type_outer": null,
                    "type_inner": "CSPTimestamp",
                    "Description": "\"expirationDate\":     The timer has a fixed expiration date.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "81",
                    "Size": "4",
                    "type_outer": null,
                    "type_inner": "CSPDuration",
                    "Description": "\"expirationPerid\":     Maximum time limit before the timer expires.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A2",
                    "Size": "6..9",
                    "type_outer": null,
                    "type_inner": "CSPTimeout",
                    "Description": "\"timeoutValue\":     Specifys if the timer is re-computing the time value on each usage.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": [
                "CSPResourceParams"
            ]
        },
        "CSPEventData": {
            "id": "CSPEventData",
            "caption": "ASN 6-61: Audit: ASN.1 Definition for CSPEventData",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPEventData",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "A0",
                    "Size": "16",
                    "type_outer": null,
                    "type_inner": "CSPEventDataUpdateCSP",
                    "Description": "\"updateCSPEvent\":     Event-specific data for: CSP software update started or has finished.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A1",
                    "Size": "42..44",
                    "type_outer": null,
                    "type_inner": "CSPEventDataUpdateConfig",
                    "Description": "\"updateConfigEvent\":     Event-specific data for: Config updated successful.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A2",
                    "Size": "22",
                    "type_outer": null,
                    "type_inner": "CSPEventDataSetTime",
                    "Description": "\"setTimeEvent\":     Event-specific data for: Reference time updated.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A3",
                    "Size": "6..10",
                    "type_outer": null,
                    "type_inner": "CSPEventDataGeneralError",
                    "Description": "\"generalErrorEvent\":     Event-specific data for: Reference time updated.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A4",
                    "Size": "5..6",
                    "type_outer": null,
                    "type_inner": "CSPEventDataResource",
                    "Description": "\"generalResourceEvent\":     Event-specific data for: General resource-specific events.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A5",
                    "Size": "8..10",
                    "type_outer": null,
                    "type_inner": "CSPEventDataKeyDerivation",
                    "Description": "\"keyDerivationEvent\":     Event-specific data for: Successful key derivation.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A6",
                    "Size": "11..14",
                    "type_outer": null,
                    "type_inner": "CSPEventDataKeyAgreement",
                    "Description": "\"keyAgreementEvent\":     Event-specific data for: Shared secret computed successfully.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "A7",
                    "Size": "8..9",
                    "type_outer": null,
                    "type_inner": "CSPEventDataPasswordFailure",
                    "Description": "\"passwordCheckFailedEvent\":     Event-specific data for: Password verification failed.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": [
                "CSPLogMessage"
            ]
        },
        "CSPSource": {
            "id": "CSPSource",
            "caption": "ASN 6-73b: Signature: ASN.1 Definition for CSPSource",
            "table": [
                {
                    "Tag": "CHOICE",
                    "Size": " ",
                    "type_outer": null,
                    "type_inner": "CSPSource",
                    "Description": " ",
                    "Presence": " "
                },
                {
                    "Tag": "80",
                    "Size": "1",
                    "type_outer": null,
                    "type_inner": "CSPFieldSource",
                    "Description": "\"fieldSource\":    Type of the source, e.g., signing key or event trigger resource.",
                    "Presence": "CONDITIONAL"
                },
                {
                    "Tag": "81",
                    "Size": "1..2",
                    "type_outer": null,
                    "type_inner": "CSPResourceId",
                    "Description": "\"resourceId\":    A specific resource used as the data source.",
                    "Presence": "CONDITIONAL"
                }
            ],
            "used_in": [
                "CSPField"
            ]
        }
    },
    "OCTET STRING": {
        "CSPEncryptResponse": {
            "id": "CSPEncryptResponse",
            "caption": "ASN 7-22: Attestations: ASN.1 Definition for CSPEncryptResponse",
            "table": [
                {
                    "Name": "CSPEncryptResponse",
                    "Size": "0..32767",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "Response of the CSPEncrypt command: the encrypted data."
                }
            ],
            "used_in": []
        },
        "CSPDecryptResponse": {
            "id": "CSPDecryptResponse",
            "caption": "ASN 7-24: Attestations: ASN.1 Definition for CSPDecryptResponse",
            "table": [
                {
                    "Name": "CSPDecryptResponse",
                    "Size": "0..32767",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "Response of the CSPDecrypt command: the decrypted data."
                }
            ],
            "used_in": []
        },
        "CSPConfigName": {
            "id": "CSPConfigName",
            "caption": "ASN 5-7: Core: ASN.1 Definition for CSPConfigName",
            "table": [
                {
                    "Name": "CSPConfigName",
                    "Size": "32",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "Name of the configuration of this CSP Instance; set by the CSP Admin."
                }
            ],
            "used_in": [
                "CSPSettings",
                "CSPSignedConfigData",
                "CSPEventDataUpdateConfig"
            ]
        },
        "CSPAPIVersion": {
            "id": "CSPAPIVersion",
            "caption": "ASN 5-10: Core: ASN.1 Definition for CSPAPIVersion",
            "table": [
                {
                    "Name": "CSPAPIVersion",
                    "Size": "3",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "Version of the Java Card CSP API (Major, Minor, Patch)."
                }
            ],
            "used_in": [
                "CSPPlatform"
            ]
        },
        "CSPELFVersion": {
            "id": "CSPELFVersion",
            "caption": "ASN 5-11: Core: ASN.1 Definition for CSPELFVersion",
            "table": [
                {
                    "Name": "CSPELFVersion",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "Version of an CSP Application Executable Load File (Major, Minor)."
                }
            ],
            "used_in": [
                "CSPPlatform",
                "CSPEventDataUpdateCSP",
                "CSPEventDataUpdateCSP"
            ]
        },
        "CSPAID": {
            "id": "CSPAID",
            "caption": "ASN 5-12: Core: ASN.1 Definition for CSPAID",
            "table": [
                {
                    "Name": "CSPAID",
                    "Size": "5..16",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "Application Identifier (AID) of an Application or a Security Domain."
                }
            ],
            "used_in": [
                "CSPPlatform",
                "CSPClientReference",
                "CSPClientApplication",
                "CSPApplicationSD"
            ]
        },
        "CSPBoolean": {
            "id": "CSPBoolean",
            "caption": "ASN 5-13: Core: ASN.1 Definition for CSPBoolean",
            "table": [
                {
                    "Name": "CSPBoolean",
                    "Size": "2",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "Secure boolean: TRUE is 0x7878, FALSE is 0x8787, other are not defined."
                }
            ],
            "used_in": [
                "CSPVerifySignatureResponse",
                "CSPSetTimeResponse"
            ]
        },
        "CSPChallenge": {
            "id": "CSPChallenge",
            "caption": "ASN 5-14: Core: ASN.1 Definition for CSPChallenge",
            "table": [
                {
                    "Name": "CSPChallenge",
                    "Size": "16..512",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "Challenge or nonce."
                }
            ],
            "used_in": [
                "CSPSystemAttestation"
            ]
        },
        "CSPSignature": {
            "id": "CSPSignature",
            "caption": "ASN 5-15: Core: ASN.1 Definition for CSPSignature",
            "table": [
                {
                    "Name": "CSPSignature",
                    "Size": "64..65536",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "Digital signature. Covers traditional RSA/ECDSA (512 bytes) and PQC (65KB)."
                }
            ],
            "used_in": [
                "CSPSignResponse",
                "CSPVerifySignature",
                "CSPSetTime",
                "CSPPlatformAttestation",
                "CSPConfigAttestation",
                "CSPDataAttestation",
                "CSPKeyPoPAttestation",
                "CSPSignedPoPData"
            ]
        },
        "CSPResourceValue": {
            "id": "CSPResourceValue",
            "caption": "ASN 5-20: Resource: ASN.1 Definition for CSPResourceValue",
            "table": [
                {
                    "Name": "CSPResourceValue",
                    "Size": "64..32768",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "The value of a public key, counter or timer resource."
                }
            ],
            "used_in": [
                "CSPSignedData",
                "CSPPopData",
                "CSPPopData"
            ]
        },
        "CSPTimestamp": {
            "id": "CSPTimestamp",
            "caption": "ASN 6-50: Time: ASN.1 Definition for CSPTimestamp",
            "table": [
                {
                    "Name": "CSPTimestamp",
                    "Size": "8",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "Unix timestamp in seconds as 8-byte signed int (292 billion years >1970)."
                }
            ],
            "used_in": [
                "CSPSetTime",
                "CSPTimers",
                "CSPManualTimer",
                "CSPEventDataSetTime",
                "CSPEventDataSetTime"
            ]
        },
        "CSPDuration": {
            "id": "CSPDuration",
            "caption": "ASN 6-51: Time: ASN.1 Definition for CSPDuration",
            "table": [
                {
                    "Name": "CSPDuration",
                    "Size": "4",
                    "type_outer": null,
                    "type_inner": "OCTET STRING",
                    "Description": "Duration in seconds, represented as 4-byte signed integer (up to 68 years)."
                }
            ],
            "used_in": [
                "CSPTimers",
                "CSPManualTimer"
            ]
        }
    },
    "BIT STRING": {
        "CSPAccessControlRules": {
            "id": "CSPAccessControlRules",
            "caption": "ASN 5-28: Access: ASN.1 Definition for CSPAccessControlRules",
            "table": [
                [
                    "b15",
                    "b14",
                    "b13",
                    "b12",
                    "b11",
                    "b10",
                    "b9",
                    "b8",
                    "b7",
                    "b6",
                    "b5",
                    "b4",
                    "b3",
                    "b2",
                    "b1",
                    "b0",
                    "CSPAccessControlRules"
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "0",
                    "-",
                    "-",
                    "-",
                    "1",
                    "\"ANY_USE\": 1. Bit: all Client Applications are granted with ACCESS_USE."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "0",
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "\"ANY_SETUP\": 2. Bit: all Client Applications are granted with ACCESS_SETUP."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "0",
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "\"ANY_CLEAR\": 3. Bit: all Client Applications are granted with ACCESS_CLEAR."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "0",
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "\"ANY_MOVE\": 4. Bit: all Client Applications are granted with ACCESS_MOVE."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "0",
                    "\"OWNER_USE\": 5. Bit: only Owner Application is granted with ACCESS_USE."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "0",
                    "-",
                    "\"OWNER_SETUP\": 6. Bit: only Owner Application is granted with ACCESS_SETUP."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "0",
                    "-",
                    "-",
                    "\"OWNER_CLEAR\": 7. Bit: only Owner Application is granted with ACCESS_CLEAR."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "0",
                    "-",
                    "-",
                    "-",
                    "\"OWNER_MOVE\": 8. Bit: only Owner Application is granted with ACCESS_MOVE."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "\"ADMIN_USE\": 9. Bit: the CSP Admin is granted with ACCESS_USE."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "\"ADMIN_SETUP\": 10. Bit: the CSP Admin is granted with ACCESS_SETUP."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "\"ADMIN_CLEAR\": 11. Bit: the CSP Admin is granted with ACCESS_CLEAR."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "\"ADMIN_MOVE\": 12. Bit: the CSP Admin is granted with ACCESS_MOVE."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "\"CLIENT_USE\": 13. Bit: all off-card Clients are granted with ACCESS_USE."
                ],
                [
                    "-",
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "\"CLIENT_SETUP\": 14. Bit: all off-card Clients are granted with ACCESS_SETUP."
                ],
                [
                    "-",
                    "1",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "\"CLIENT_CLEAR\": 15. Bit: all off-card Clients are granted with ACCESS_CLEAR."
                ],
                [
                    "1",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "-",
                    "\"CLIENT_MOVE\": 16. Bit: all off-card Client are granted with ACCESS_MOVE."
                ]
            ],
            "used_in": [
                "CSPAccessControl"
            ]
        },
        "CSPTimeSynchronization": {
            "id": "CSPTimeSynchronization",
            "caption": "ASN 6-47: Time: ASN.1 Definition for CSPTimeSynchronization",
            "table": [
                [
                    "b7",
                    "b6",
                    "b5",
                    "b4",
                    "b3",
                    "b2",
                    "b1",
                    "b0",
                    "CSPTimeSynchronization"
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "x",
                    "x",
                    "-",
                    "1",
                    "\"TIME_SYNC_FROM_TA\": Update the reference time from TA2 certificates during EAC v2."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "-",
                    "x",
                    "x",
                    "1",
                    "-",
                    "\"TIME_SYNC_FROM_CLIENT\": Permit Client Applications to set the reference time."
                ],
                [
                    "-",
                    "-",
                    "-",
                    "1",
                    "x",
                    "x",
                    "-",
                    "-",
                    "\"TIME_SYNC_ENFORCE_NEWER\": Accept only newer timestamps."
                ],
                [
                    "-",
                    "-",
                    "1",
                    "-",
                    "x",
                    "x",
                    "-",
                    "-",
                    "\"TIME_SYNC_PERSIST\": Persist the reference time."
                ],
                [
                    "-",
                    "1",
                    "-",
                    "-",
                    "x",
                    "x",
                    "-",
                    "-",
                    "\"TIME_SYNC_VERIFY_SIG\": Verify the timestamp signature."
                ],
                [
                    "1",
                    "-",
                    "-",
                    "-",
                    "x",
                    "x",
                    "-",
                    "-",
                    "\"TIME_SYNC_VERIFY_SIG_WITH_CHALLENGE\": Verify the timestamp signature using a challenge generated by CSP."
                ]
            ],
            "used_in": [
                "CSPTimeSupport",
                "CSPTimeSettings"
            ]
        }
    },
    "missingList": {}
};

/* ######################################## JSON END ######################################## */

/* ######################################## */

/**
 * Globally declared Regular Expressions
 */

const re_bin_1 = RegExp('(0b)?([01]{4})+');
const re_bin_2 = RegExp('[01]{4}', 'g');
const re_bin = RegExp('(0b)?([01]{8})+');
const re_bin_short = RegExp('(0b)?([01]+)');
const re_hex = RegExp('(0x)?([0-9a-fA-F]+)');
const re_binary = RegExp('0b([01]{2})([01]{1})([01]{5})(([01]{8})*)?');

/* ######################################## */

/**
 * converts decimal Number to binary representation
 * @param {number} dec - decimal Number
 * @returns {string} binary representation with leading "0b"
 */
function dec2bin(dec) {
    return '0b' + (dec >>> 0).toString(2);
}

/* ######################################## */

/**
 * converts decimal Number to hexadecimal representation
 * @param {number | string} _value - decimal Number
 * @returns {string} hexadecimal representation without leading "0x"
 */
function hhex(_value) {
    // return hex number without '0x' in front, with even number
    let value_int;
    if (typeof _value == "string") {
        // if empty return empty early
        if (_value.length == 0) {
            return '';
        }
        value_int = parseInt(_value, 10);
    } else if (typeof _value == "number") {
        value_int = _value;
    }
    let value_hex = value_int.toString(16).toUpperCase();
    if (value_hex.length % 2) {
        value_hex = '0' + value_hex;
    }
    return value_hex;
}

/* ######################################## */

/**
 * converts decimal Number to binary representation without "0b" in front
 * @param {number} _value - decimal Number
 * @returns {string} binary representation
 */
function bbin(_value) {
    /* return binary number without '0b' in front */
    return dec2bin(_value).slice(2);
}

/* ######################################## */

/**
 * defines length octet array based upon length value number
 * @param {number} _length_value - length value, number of bytes in tlv structure
 * @returns {Array} array of length octets in binary representation
 */
function length_octets(_length_value) {
    /* create the length octets encoding a specific length value */
    let octets = [];
    // definite, short
    if (_length_value < 128) {
        octets.push(bbin(_length_value).padStart(8, '0'));
    }
    // definite, long
    else if (_length_value >= 128) {
        let bin_val = bbin(_length_value);
        let n = bin_val.length % 8;
        if (n != 0) {
            n = 1;
        }
        n += Math.floor(Number(bin_val.length / 8));
        octets.push('1' + bbin(n).padStart(7, '0'));
        bin_val = bin_val.padStart(8 * n, '0');
        for (let i = 0; i < n; i++) {
            octets.push(bin_val.slice(0 + 8 * i, 8 + 8 * i));
        }
    }
    // indefinite
    else {
        octets.push('10000000');
    }
    return octets
}

/* ######################################## */

/**
 * fills binary representation with leading zeros to reach multiple of 8 length
 * @param {string} _tag - binary representation of arbitrary length
 * @returns {string} binary representation with leading zeros for length of multiples of 8
 */
function binary_leading_zeros(_tag) {
    /* convert binary number with optional leading "0b" to binary number with leading zeros */

    const res = _tag.match(re_bin_short);
    // // console.log('res =',res);
    if (!(res)) {
        throw Error('Parameter should be binary with optional leading "0b".');
    }
    let content = res[2];
    while ((content.length) % 8) {
        content = '0' + content;
    }
    if (res[1]) {
        content = res[1] + content;
    }
    return content; // .slice(2)
}

/* ######################################## */

/**
 * converts binary tag as multiple of 4 length to byte representation with leading zeros
 * @param {string} _tag - binary-tag as multiple of 4 zeros and ones
 * @returns {string} hex-tag / byte representation for input
 */
function hex_tag(_tag) {
    /* convert binary-tag to hex-tag */
    _tag = binary_leading_zeros(_tag)
    if (_tag.match(re_bin_1)) {

        const re_bin_2_res = [..._tag.matchAll(re_bin_2)];
        let res = [];
        for (let i = 0; i < re_bin_2_res.length; i++) {
            res.push(parseInt(re_bin_2_res[i], 2).toString(16));
        }
        return res.join('').toUpperCase();
    }
    throw Error('The parameter ' + _tag + ' should be a bit value with a length of 4 multiples')
}

/* ######################################## */

/**
 * creates hex representation based upon length value
 * @param {number} _length_value - length value number
 * @returns {string} hex representation
 */
function length_octets_hex(_length_value) {
    /* return length octets in hex representation */
    let bin_res = length_octets(_length_value);
    let hex_res = [];
    for (let i = 0; i < bin_res.length; i++) {
        hex_res.push(hex_tag(bin_res[i]));
    }
    return hex_res.join('');
}

/* ######################################## */

// /**
//  * calculates the number of length bytes
//  * @param {number} _length_value - length of bytes of tlv value bytes
//  * @returns {number} length of bytes of tlv length bytes
//  */
// function length_octets_number(_length_value) {
//     /* return the number of length octets necessary */
//     return (length_octets(_length_value)).length;
// }

/* ######################################## */

/**
 * identifies dict key that contains the type in question
 * @param {JSON} _dict - dictionary / JSON to be analyzed
 * @param {string} _type - type in question
 * @returns {string} key value containing type
 */
function identify_dict_list(_dict, _type) {
    /* used to identify the list type within the json_dict containing _type */
    let list_type_identified = null;
    for (const list_type in _dict) {
        // // console.log('_type ->',_type)
        // // console.log('_dict[list_type] ->',_dict[list_type])
        if (_type in _dict[list_type]) {
            list_type_identified = list_type
            break
        }
    }
    // // console.log('list_type_identified ->',list_type_identified)
    return list_type_identified
}

/* ######################################## */

/**
 * analyzes tlv tag value and returns the containing information
 * @param {string} _tag - tag value according to ITU X.680/X.690
 * @returns {Array} 3 value Array that contains the information of the tag
 */
function interpret_tag(_tag) {//-> tuple:
    /* alternative:
    const byteVal = parseInt(hexTag, 16); 
    const tagClass = (byteVal >> 6) & 0b11;    // 0..3
    const isConstructed = (byteVal >> 5) & 0b1; // 0 / 1
    const tagNumber = (byteVal & 0x1F);        // 0..31
    return [tagClass, isConstructed, tagNumber];
    */

    /* interpret binary-tag according to */
    const res_bin = _tag.match(re_bin);
    const res_hex = _tag.match(re_hex);
    // cleanup input
    _tag = _tag.replace('"', '').replace("'", "");
    if (res_bin) {
        // binary representation
        _tag = binary_leading_zeros(_tag);
    } else if (res_hex) {
        // hex representation
        if (undefined == res_hex[1]) {
            _tag = '0x' + res_hex[2];
        }
        _tag = dec2bin(Number(_tag));
        _tag = binary_leading_zeros(_tag);
    } else {
        throw Error('WRONG INPUT: {_tag}, should be hex or bin data');
    }
    // bits 8 and 7
    const _class_mapping = {
        '00': 'universal',
        '01': 'application',
        '10': 'context-specific',
        '11': 'private',
    };

    // bit 6
    const _pc_mapping = { '0': 'primitive', '1': 'constructed' };
    const res_binary = _tag.match(re_binary);
    if (res_binary) {
        if (
            res_binary[4] && res_binary[3] != '11111' || res_binary[3] == '11111' && !res_binary[4]) {
            throw Error('interpret_tag: non-conforming input (1)');
        };
        let temp_2;
        if ('11111' == res_binary[3]) {
            if (res_binary[4].slice(-8, -7) != '0') {
                throw Error('interpret_tag: non-conforming input (2)')
            }
            let temp_1 = []
            for (let i = 0; i < res_binary[4].length / 8; i++) {
                temp_1.push(res_binary[4].slice(8 * i, 8 + 8 * i));
            }
            for (let i = 0; i < temp_1.length; i++) {
                let item = temp_1[i];
                if (item[0] != '1' && i < temp_1.length - 1) {
                    throw Error('interpret_tag: non-conforming input (3)');
                }
                temp_1[i] = item.slice(1);
            }
            temp_2 = Number('0b' + temp_1.join(''), 2);
        } else {
            temp_2 = Number('0b' + res_binary[3], 2);
        }
        return [_class_mapping[res_binary[1]], _pc_mapping[res_binary[2]], temp_2];
    }
    throw Error('The parameter _tag should be an eight bit value, conforming to ITU X.690');
}




function interpret_tag_2(hexTag) {
    const classOptions = {
        '00': 'universal',
        '01': 'application',
        '10': 'context-specific',
        '11': 'private'
    }

    const byteVal = parseInt(hexTag, 16); 
    const tagClass = (byteVal >> 6) & 0b11;    // 0..3
    const isConstructed = (byteVal >> 5) & 0b1; // 0 / 1
    const tagNumber = (byteVal & 0x1F);        // 0..31
    return [tagClass, isConstructed, tagNumber];
}

console.log(interpret_tag('80'));
console.log(interpret_tag('0x80'));
console.log(interpret_tag_2('80'));
console.log(interpret_tag_2('0x80'));



/* ######################################## */

/**
 * creates binary representation for ITU X.690 compliant tag
 * @param {string} _class - universal (00), application (01), context-specific (10), private (11)
 * @param {string} _pc - primitive (0) or constructed (1)
 * @param {number} _num - number encoded inside of tag
 * @returns {string} binary representation of tag
 */
function get_bin_tag(_class, _pc, _num) {
    /*_class = {universal|application|context-specific|private}
    _pc = {primitive|constructed}*/
    _class = _class.toLowerCase()
    _pc = _pc.toLowerCase()
    // Bits 8 and 7, ITU X.690, Table 1, "Encoding of class of tag"
    const _class_mapping = {
        'universal': '00',
        'application': '01',
        'context-specific': '10',
        'private': '11',
    };
    if (!(_class in _class_mapping)) {
        throw Error(
            'The parameter _class should either be "universal", '
            + '"application", "context-specific" or "private"'
        );
    }
    // Bit 6, ITU X.690, "8.1.2.5 Bit 6 shall be set to zero if
    // the encoding is primitive, and shall be set to one if the
    // encoding is constructed."
    const _pc_mapping = { 'primitive': '0', 'constructed': '1' };
    if (!(_pc in _pc_mapping)) {
        throw Error(
            'The parameter _pc should either be "primitive" or "constructed"'
        );
    }
    // bits 5 to 1
    let _num_bin;
    let tag_extension_bytes = [];
    if (_num >= 31) {
        // first bit octet is filled
        _num_bin = '11111';
        // following octets start with 1, last octet with 0
        // other bits comprise tag number that is larger than 30
        let bit_temp = bbin(_num);
        while (bit_temp.length % 7) {
            bit_temp = '0' + bit_temp;
        }
        for (let i = 0; i < bit_temp.length / 7; i++) {
            tag_extension_bytes.push(bit_temp.substring(0 + 7 * i, 7 * (i + 1)))
        }
        for (let i = 0 ; i < tag_extension_bytes.length; i++) {
            if (i == tag_extension_bytes.length - 1) {
                tag_extension_bytes[i] = '0' + tag_extension_bytes[i];
            } else {
                tag_extension_bytes[i] = '1' + tag_extension_bytes[i];
            }
        }
        // raise ValueError('The parameter _num should be lower than 32')
    } else {
        _num_bin = bbin(_num);
        while (_num_bin.length < 5) {
            _num_bin = '0' + _num_bin;
        }
    }
    // return combined byte value
    return (
        '0b'
        + _class_mapping[_class]
        + _pc_mapping[_pc]
        + _num_bin
        + tag_extension_bytes.join('')
    )
}

/* ######################################## */

/**
 * creates hex representation for ITU X.690 compliant tag
 * @param {string} _class - universal (00), application (01), context-specific (10), private (11)
 * @param {string} _pc - primitive (0) or constructed (1)
 * @param {number} _num - number encoded inside of tag
 * @returns {string} hex representation of tag
 */
function get_hex_tag(_class, _pc, _num) {
    /*return hex-version of tag*/
    return hex_tag(get_bin_tag(_class, _pc, _num));
}

/* ######################################## */

// /**
//  * converts string to hex representation for octet string
//  * @param {string} word - string in utf-8 encoding
//  * @returns {string} string in hex encoding
//  */
// function string_encoding(word) {
//     /*encodes string chars to hex-bytes*/
//     let res = [];
//     let hex_val;
//     for (let i = 0; i < word.length; i++) {//_char in word:
//         hex_val = hhex(word[i].charCodeAt(0)).toUpperCase();
//         if (hex_val.length % 2) {
//             hex_val = '0' + hex_val;
//         }
//         res.push(hex_val) // (_char,ord(_char),
//     }
//     return res.join('')
// }

/* ######################################## */

const ITU_DEFINITIONS = {
    // UNIVERSAL 0	Reserved for use by the encoding rules
    'RESERVED00': get_hex_tag('universal', 'primitive', 0),
    // UNIVERSAL 1	Boolean type
    'BOOLEAN': get_hex_tag('universal', 'primitive', 1),
    // UNIVERSAL 2	Integer type
    'INTEGER': get_hex_tag('universal', 'primitive', 2),
    // UNIVERSAL 3	Bitstring type
    'BIT STRING': get_hex_tag('universal', 'primitive', 3),
    // UNIVERSAL 4	Octetstring type
    'OCTET STRING': get_hex_tag('universal', 'primitive', 4),
    // UNIVERSAL 5	Null type
    'NULL': get_hex_tag('universal', 'primitive', 5),
    // UNIVERSAL 6	Object identifier type
    'OBJECT IDENTIFIER': get_hex_tag('universal', 'primitive', 6),
    // UNIVERSAL 7	Object descriptor type
    'OBJECT DESCRIPTOR': get_hex_tag('universal', 'primitive', 7),
    // UNIVERSAL 8	External type and Instance-of type
    'EXTERNAL': get_hex_tag('universal', 'primitive', 8),
    'INSTANCE OF': get_hex_tag('universal', 'primitive', 8),
    // UNIVERSAL 9	Real type
    'REAL': get_hex_tag('universal', 'primitive', 9),
    // UNIVERSAL 10	Enumerated type
    'ENUMERATED': get_hex_tag('universal', 'primitive', 10),
    // UNIVERSAL 11	Embedded-pdv type
    'EMBEDDED PDV': get_hex_tag('universal', 'primitive', 11),
    // UNIVERSAL 12	UTF8String type
    'UTF8STRING': get_hex_tag('universal', 'primitive', 12),
    // UNIVERSAL 13	Relative object identifier type
    'RELATIVE OBJECT IDENTIFIER': get_hex_tag('universal', 'primitive', 13),
    // UNIVERSAL 14	The time type
    'THE TIME': get_hex_tag('universal', 'primitive', 14),
    // UNIVERSAL 15	Reserved for future editions of this Recommendation | International Standard
    'RESERVED15': get_hex_tag('universal', 'primitive', 15),
    // UNIVERSAL 16	Sequence and Sequence-of types
    'SEQUENCE': get_hex_tag('universal', 'constructed', 16),
    'SEQUENCE OF': get_hex_tag('universal', 'constructed', 16),
    // UNIVERSAL 17	Set and Set-of types
    'SET': get_hex_tag('universal', 'constructed', 17),
    'SET OF': get_hex_tag('universal', 'constructed', 17),
    // UNIVERSAL 18-22, 25-30	Character string types
    'VISIBLE STRING': get_hex_tag('universal', 'primitive', 26),
    // UNIVERSAL 23-24	UTCTime and GeneralizedTime
    // UNIVERSAL 31-34	DATE, TIME-OF-DAY, DATE-TIME and DURATION respectively
    // UNIVERSAL 35	OID internationalized resource identifier type
    'OID': get_hex_tag('universal', 'primitive', 35),
    // UNIVERSAL 36	Relative OID internationalized resource identifier type
    'RELATIVE OID': get_hex_tag('universal', 'primitive', 36),
    // UNIVERSAL 37-...	Reserved for addenda to this Recommendation | International Standard
    // 'SUCCESS': '90',
};

/* ######################################## */

/**
 * returns interpretation of bit table
 * @param {Array} _table - input table of bit type
 * @returns {Array} returns interpretation of bit table and byte size
 */
function interpret_bit_table(_table) {// -> tuple[dict, int]:
    /*handle bit string example input*/
    let res = {};
    const bit_size = _table[0].length - 1;
    for (let i = 0; i < _table.length; i++) { // i, line in enumerate(_table)
        if (i == 0) {
            continue;
        }
        let key = _table[i][_table[i].length - 1].split(':', 1)[0].replaceAll('"', '');
        for (let j = 0; j < _table[i].length; j++) { // j, item in enumerate(line)
            if (_table[i][j] == '1') {
                res[key] = bit_size - j - 1;
            }
        }
    }
    return [res, bit_size];
}

/* ######################################## */

/**
 * constructs bit mask out of bit table and chosen values
 * @param {Array} _table - input table of bit type
 * @param {Array} _values - chosen values out of bitmask
 * @returns {string} returns hex string of intended meaning
 */
function construct_bit_mask(_table, _values) {
    /*used to interpret the bit mask table*/
    const interpret_bit_table_table = interpret_bit_table(_table);
    // const bit_table_meaning = interpret_bit_table_table[0];
    // const bit_size = interpret_bit_table_table[1];
    let res = [];
    for (let i = 0; i < interpret_bit_table_table[1]; i++) {
        res.push('0');
    }
    for (let i = 0; i < _values.length; i++) {
        // console.log(`interpret_bit_table_table[0][_values[${i}]] = ${interpret_bit_table_table[0]}[${_values[i]}] = ${interpret_bit_table_table[0][_values[i]]}`);
        res[interpret_bit_table_table[0][_values[i]]] = '1';
    }
    const res_rev = res.reverse();
    const res_bin = res_rev.join('');
    const res_int = parseInt(res_bin, 2);
    const res_hex = hhex(res_int);
    return res_hex;
}

/* ######################################## */

/**
 * constructs bit mask out of JS result
 * @param {JSON} _json - json object to read information out of
 * @param {string} _param_name - name of bit string param
 * @param {object} _values - object containing line-bool mapping
 * @returns {string} constructed hex representation for bitstring
 */
function construct_bit_mask_js(_json, _param_name, _values) {
    const bit_string_table = _json['BIT STRING'][_param_name].table;
    // return prematurely if empty is true
    if (_values.empty) {
        const bit_mask_length = hhex(parseInt('1'.repeat(bit_string_table[0].length - 1),2)).length;
        return '0'.repeat(bit_mask_length);
    }
    // extract boolean values of checkboxes
    let value_names = [];
    const keys_array = Object.keys(_values);
    let values_array = [];
    for (let i = 0; i < keys_array.length; i++) {
        // skip entry "empty"
        if (keys_array[i] != 'empty') {
            values_array.push(_values[keys_array[i]]);
        }
    }
    // skip table header
    for (let i = 1; i < bit_string_table.length; i++) {
        // check if bit-entry is checked true
        // "i - 1" because first entry is empty
        if (values_array[i - 1]) {
            // push name of bit-entry for further processing
            value_names.push(bit_string_table[i][bit_string_table[i].length - 1].split(':', 1)[0].replaceAll('"', ''));
        }
    }
    // construct bit mask
    if (value_names.length > 0) {
        return construct_bit_mask(bit_string_table, value_names);
    } else {
        return '';
    }
}

/* ######################################## */

/**
 * interprets enum entries in input table
 * @param {Array} _table - input table
 * @param {string} _value - value to be used out of table
 * @returns {string} interpretation result
 */
function interpret_enum(_table, _value) {
    /*handle enum example input*/
    if (_value == '') {
        return '';
    }
    for (let i = 0; i < _table.length; i++) { // line in _table)
        if (_table[i]['Name'] == _value) {
            return hhex(_table[i]['Value']);
        }
    }
    throw Error('ENUMERATED value ' + _value + ' is not recognized.');
}

/* ######################################## */

/**
 * identifies parameter name based on tag and json table
 * @param {JSON} json_content - json object containing ASN.1 definitions
 * @param {string} obj_type - type of an object to be analyzed
 * @param {string} obj_name - name of an object to be analyzed
 * @param {string} param_tag - tag that is to be identified
 * @returns {Array} array containing type_outer and type_inner
 */
function identify_param_name(json_content, obj_type, obj_name, param_tag) {
    for (let i = 0; i < json_content[obj_type][obj_name].table.length; i++) {
        if (param_tag === json_content[obj_type][obj_name].table[i].Tag) {
            return [
                json_content[obj_type][obj_name].table[i].type_outer,
                json_content[obj_type][obj_name].table[i].type_inner
            ];
        }
    }
    return ['not found', 'not found'];
}

/* ######################################## */

/**
   * Custom JSON.stringify:
   *  - walks through objekts recursivly
   *  - keys are sorted by interpret_tag(key)[2] (tagNumber)
   *  - arrays stay in in original order
   *  - strings, numbers, booleans are rendered in JSON-Style
   *  - working with indentation (default to 2 whitespaces)
   * @param {any} value - The input JSON. May be an object, array, or primitive.
   * @param {number} space - The number of spaces for indentation (default: 2)
   * @param {number} currentIndent - The current indentation level (default: 0)
   * @returns {string} The JSON-like string representation of the input.
   */
function asn1Stringify(value, space = 2, currentIndent = 0) {
    // 1) primitive variable types
    if (value === null) {
      return "null";
    }
    const typeOfVal = typeof value;
    if (typeOfVal === "string") {
      return `"${escapeString(value)}"`;
    }
    if (typeOfVal === "number") {
      return String(value);
    }
    if (typeOfVal === "boolean") {
      return value ? "true" : "false";
    }
  
    // 2) arrays stay in original order
    if (Array.isArray(value)) {
      if (value.length === 0) {
        return "[]";
      }
      const nextIndent = currentIndent + space;
      const indentStr  = " ".repeat(nextIndent);
      const closingIndentStr = " ".repeat(currentIndent);
  
      const items = value.map((item) =>
        asn1Stringify(item, space, nextIndent)
      );
      // JSON-style
      return `[\n${indentStr}${items.join(`,\n${indentStr}`)}\n${closingIndentStr}]`;
    }
  
    // 3) objects (sorted by interpret_tag(key)[2])
    // test if typeof value is object
    if (typeof value === "object") {
      const keys = Object.keys(value);
  
      // sorting by tag-number:
      keys.sort((a, b) => {
        const tagNumA = interpret_tag(a)[2];
        const tagNumB = interpret_tag(b)[2];
        return tagNumA - tagNumB;
      });
  
      if (keys.length === 0) {
        return "{}";
      }
  
      const nextIndent = currentIndent + space;
      const indentStr  = " ".repeat(nextIndent);
      const closingIndentStr = " ".repeat(currentIndent);
  
      const items = keys.map((k) => {
        const valStr = asn1Stringify(value[k], space, nextIndent);
        return `"${k}": ${valStr}`;
      });
  
      // JSON-style
      return `{\n${indentStr}${items.join(`,\n${indentStr}`)}\n${closingIndentStr}}`;
    }
  
    // 4) fallback (should not happen): undefined, function, symbol...
    return "null";
  }
  
  
  /**
   * Minimal escaping function, can be extended.
   * For full JSON-stringify-functionality also \b \f \n \r \t etc. need to be covered.
   * @param {string} str - The input string to escape.
   * @returns {string} The escaped string.
   */
  function escapeString(str) {
    return str
      .replace(/\\/g, "\\\\")   // backslash
      .replace(/"/g, "\\\"");   // quotes
  }

/* ######################################## */

/**
 * converts output object that collected all inputs to hex string
 * @param {JSON} json_content - object containing ASN.1 definitions
 * @param {string} obj_name - name of object to be analyzed
 * @param {object} output - object containing output values
 * @param {boolean} show_if_empty - flag to show empty values
 * @returns {string} hex string representation of output
 */
function handle_output_json(json_content, obj_name, output, show_if_empty) {
    // console.log(`handle_output_json(json_content, ${obj_name}, ${output}, ${show_if_empty})`);
    const delim = '';
    // get object keys sorted by tag number
    const keys = Object.keys(output).sort((a, b) => {
        const tagNumA = interpret_tag(a)[2];
        const tagNumB = interpret_tag(b)[2];
        return tagNumA - tagNumB;
    });
    let result = [];
    const obj_type = identify_dict_list(json_content, obj_name);
    // console.log(`obj_type = ${obj_type}`);
    for (let i = keys.length - 1; i >= 0; i--) {
        let show_null_entry = false;
        // console.log(`keys[${i}] = ${keys[i]}`);
        const param_name = identify_param_name(json_content, obj_type, obj_name, keys[i]);
        const param_type = identify_dict_list(json_content, param_name[1]);
        let value;
        // SET OF / SEQUENCE OF preparation
        if (param_name[0] === 'SET OF' || param_name[0] === 'SEQUENCE OF') {
            value = [];
        }
        // handle output content based on type
        if (param_type === 'SEQUENCE' || param_type === 'CHOICE') {
            if (param_name[0] === 'SET OF' || param_name[0] === 'SEQUENCE OF') {
                for (const key in output[keys[i]]) {
                    value.push(handle_output_json(json_content, param_name[1], output[keys[i]][key], false));
                }
            } else {
                value = handle_output_json(json_content, param_name[1], output[keys[i]], false);
            }
        } else {
            if (output[keys[i]].length == 0) {
                continue;
            } else if (param_name[1] === 'NULL') {
                value = '';
                show_null_entry = output[keys[i]];
            } else if (param_type === 'INTEGER' || param_name[1] === 'INTEGER') {
                if (param_name[0] === 'SET OF' || param_name[0] === 'SEQUENCE OF') {
                    for (const key in output[keys[i]]) {
                        if (output[keys[i]][key] === '') {
                            continue;
                        }
                        value.push(hhex(output[keys[i]][key]));
                    }
                } else {
                    value = hhex(output[keys[i]]);
                }
            } else if (param_type === 'ENUMERATED') {
                const enum_table = json_content[param_type][param_name[1]].table;
                if (param_name[0] === 'SET OF' || param_name[0] === 'SEQUENCE OF') {
                    for (const key in output[keys[i]]) {
                        if (output[keys[i]][key] === '') {
                            continue;
                        }
                        value.push(interpret_enum(enum_table, output[keys[i]][key]));
                    }
                } else {
                    value = interpret_enum(enum_table, output[keys[i]]);
                }
            } else if (param_type === 'BIT STRING') {
                value = construct_bit_mask_js(json_content, param_name[1], output[keys[i]]);
            } else if (param_type === 'OCTET STRING' || param_name[1] === 'OCTET STRING') {
                value = output[keys[i]]; // string_encoding(...) not used anymore
            } else if (param_type === 'BOOLEAN' || param_name[1] === 'BOOLEAN') {
                value = hhex(Number(output[keys[i]]));
            } else {
                console.log(`CASE FOR TYPE ${param_name[0]} ${param_name[1]} (${param_type}) NOT FOUND`)
            }
        }
        // show only if show_if_empty flag is true else skip entry
        if (Array.isArray(value)) { // && value.join('').length == 0
            value = value.filter(item => item.length > 0);
        }
        if (show_null_entry) {
            //
        } else if (value.length == 0 && !show_if_empty) {
            continue;
        } else {
            console.log(`value = "${value}"; show_if_empty = ${show_if_empty}; show_null_entry = ${show_null_entry}`);
        }
        // combine SET OF / SEQUENCE OF items with correct tag for item type
        if (param_name[0] === 'SET OF' || param_name[0] === 'SEQUENCE OF') {
            let temp = [];
            let item_tag = ITU_DEFINITIONS[param_type];
            for (let j = 0; j < value.length; j++) {
                temp.push(item_tag + delim + length_octets_hex(value[j].replaceAll(delim, '').length / 2) + delim + value[j]);
            }
            if (temp.length == 4) {
                continue;
            }
            result.push(keys[i] + delim + length_octets_hex(temp.join('').length / 2) + delim + temp.join(''));
        } else {
            result.push(keys[i] + delim + length_octets_hex(value.replaceAll(delim, '').length / 2) + delim + value);
        }
        // console.log(result);
    }
    result = result.reverse();
    if (result.length > 0) console.log(result);
    return result.join(delim);
}

// const handle_output_json_1 = handle_output_json(jsonContent, "CSPAdminCommand", test_json_output_1, true);
// console.log("handle_output_json(jsonContent, \"CSPAdminCommand\", test_json_output_1, true) = ", handle_output_json_1);
// const handle_output_json_2 = handle_output_json(jsonContent, "CSPAdminCommand", test_json_output_2, true);
// console.log("handle_output_json(jsonContent, \"CSPAdminCommand\", test_json_output_2, true) = ", handle_output_json_2);

/* ######################################## */

// Function to restrict keystroke-input to 0-9, A-F, a-f
function restrictKeyInputOctet(event) {
    const allowedKeys = ['Backspace', 'ArrowLeft', 'ArrowRight', 'Delete', 'Tab'];
    const regex = /^[0-9a-fA-F]*$/;
    // Allow control keys
    if (allowedKeys.includes(event.key) || (event.ctrlKey && event.key === 'v') || (event.metaKey && event.key === 'v')) return;
    // Prevent default action if the key is not allowed
    if (!regex.test(event.key)) event.preventDefault();
}

/* ######################################## */

// Function to restrict keystroke-input to 0-9
function restrictKeyInputInteger(event) {
    const allowedKeys = ['Backspace', 'ArrowLeft', 'ArrowRight', 'Delete', 'Tab'];
    const regex = /^[0-9]*$/;
    // Allow control keys
    if (allowedKeys.includes(event.key) || (event.ctrlKey && event.key === 'v') || (event.metaKey && event.key === 'v')) return;
    // Prevent default action if the key is not allowed
    if (!regex.test(event.key)) event.preventDefault();
}

/* ######################################## */

// Function to restrict non keystroke-input to 0-9, A-F, a-f
function restrictOtherInputOctet(event) {
    const regex = /[^0-9a-fA-F]/g;
    if (regex.test(event.target.value)) {
        event.target.value = event.target.value.replace(regex, '');
    }
}

/* ######################################## */

// Function to restrict non keystroke-input to 0-9
function restrictOtherInputInteger(event) {
    const regex = /[^0-9]/g;
    if (regex.test(event.target.value)) {
        event.target.value = event.target.value.replace(regex, '');
    }
}

/* ######################################## */

/***************************************************
 * DOM elements
 ***************************************************/
document.addEventListener("DOMContentLoaded", () => {
    const choiceSelector = document.getElementById("choiceSelector");
    const commandSelectorGroup = document.getElementById("commandSelectorGroup");
    const commandSelector = document.getElementById("commandSelector");
    const parameterForm = document.getElementById("parameterForm");
    const outputPre = document.getElementById("outputPre");

    // 1) Populate the CHOICE dropdown (e.g. CSPAdminCommand, CSPClientCommand)
    const choiceKeys = Object.keys(jsonContent.CHOICE).slice(0, 2);
    choiceKeys.forEach((choiceKey, index) => {
        const option = document.createElement("option");
        option.value = choiceKey;
        option.textContent = get_hex_tag('context-specific','constructed',index+1) + ' - ' + choiceKey;
        choiceSelector.appendChild(option);
    });

    // Store the currently selected CHOICE
    let currentChoice = null;
    // Store the currently selected Command (Tag)
    let currentCommandTag = null;
    // The type_inner for that selected Tag
    let currentTypeInner = null;


    /**
     * When the CHOICE changes, load possible commands (tags)
     */
    choiceSelector.addEventListener("change", (e) => {
        currentChoice = e.target.value;

        parameterForm.innerHTML = "";
        outputPre.textContent = "No inputs yet...";
        commandSelector.innerHTML = `<option value="" disabled selected>Please select...</option>`;

        // For demonstration, we assume each CHOICE has a "table"
        const choiceTable = jsonContent.CHOICE[currentChoice]?.table || [];
        // row 0 is header, skip it
        const commands = choiceTable.slice(1);

        commands.forEach(row => {
            const opt = document.createElement("option");
            opt.value = row.Tag;
            opt.textContent = `${row.Tag} - ${row.type_inner}`;
            commandSelector.appendChild(opt);
        });

        commandSelectorGroup.style.display = "block";
    });


    /**
     * When the command (Tag) changes, prepare the parameter form
     */
    commandSelector.addEventListener("change", (e) => {
        currentCommandTag = e.target.value;
        parameterForm.innerHTML = "";

        // Find the row that has this Tag
        const choiceTable = jsonContent.CHOICE[currentChoice]?.table || [];
        const commandRow = choiceTable.find(r => r.Tag === currentCommandTag);
        if (!commandRow) {
            outputPre.textContent = "Command/Tag not found.";
            return;
        }

        currentTypeInner = commandRow.type_inner || null;

        // If it's a SEQUENCE or something else, build the form
        if (currentTypeInner && jsonContent.SEQUENCE[currentTypeInner]) {
            createFormForSequence(currentTypeInner, parameterForm, []);
        } else {
            outputPre.textContent = `No SEQUENCE entry found for ${currentTypeInner}`;
        }
    });


    /***************************************************
     * Recursive form creation for a SEQUENCE
     ***************************************************/
    function createFormForSequence(sequenceName, container, path) {
        const seqDetails = jsonContent.SEQUENCE[sequenceName];
        if (!seqDetails || !seqDetails.table) return;

        const rows = seqDetails.table.slice(1); // skip header row [0]

        rows.forEach(item => {
            const Presence = item.Presence === "OPTIONAL" ? item.Presence : "MANDATORY";
            const fieldset = document.createElement("fieldset");
            const legend = document.createElement("legend");
            legend.textContent = `${item.Tag} - ${item.Description.split(":")[0]}`;
            fieldset.appendChild(legend);

            // Add a special class if Presence is "MANDATORY"
            if (Presence === "MANDATORY") {
                fieldset.classList.add("mandatory-fieldset");
            }

            const newPath = [...path, item.Tag];

            // Check if "type_outer" is "SET OF"
            if (item.type_outer === "SET OF" || item.type_outer === "SEQUENCE OF") {
                // We create a container that can hold multiple items of type_inner
                createSetOfContainer(item.type_inner, fieldset, newPath);
            }
            else if (item.type_inner) {
                // If "type_inner" is a SEQUENCE?
                if (jsonContent.SEQUENCE[item.type_inner]) {
                    const nestedContainer = document.createElement("div");
                    nestedContainer.className = "nested";
                    createFormForSequence(item.type_inner, nestedContainer, newPath);
                    fieldset.appendChild(nestedContainer);

                    // If "type_inner" is a BIT STRING?
                } else if (jsonContent["BIT STRING"]?.[item.type_inner]) {
                    createFormForBitString(item.type_inner, fieldset, newPath);

                    // If "type_inner" is an ENUMERATED?
                } else if (jsonContent["ENUMERATED"]?.[item.type_inner]) {
                    createIntegerField(item.type_inner, item.Description, fieldset, newPath, true, item.Length);

                    // If "type_inner" is a CHOICE?
                } else if (jsonContent["CHOICE"]?.[item.type_inner]) {
                    createChoiceField(item.type_inner, item.Description, fieldset, newPath);

                    // If "type_inner" is an INTEGER entry in jsonContent.INTEGER?
                } else if (jsonContent["INTEGER"]?.[item.type_inner] || item.type_inner === "INTEGER") {
                    // Could show dropdown with possible integer values from the table
                    createIntegerField(item.type_inner, item.Description, fieldset, newPath, false, item.Length); // , /* isInteger= */ true
                
                    // If "type_inner" is a plain OCTET STRING or entry in jsonContent["OCTET STRING"]?
                } else if (jsonContent["OCTET STRING"]?.[item.type_inner] || item.type_inner === "OCTET STRING") {
                    createOctetStringField(item.type_inner, item.Description, fieldset, newPath, item.Length);

                    // If "type_inner" is NULL
                } else if (item.type_inner === 'NULL') {
                    createNullField('', fieldset, newPath);

                    // If none of the above -> treat as a primitive type
                } else {
                    createPrimitiveField(item.type_inner, item.Description, fieldset, newPath);
                }
            } else {
                // If type_inner is missing, fallback
                createPrimitiveField("text", item.Description, fieldset, newPath);
            }

            container.appendChild(fieldset);
        });

        refreshOutput();
    }


    /***************************************************
     * Create a container for "SET OF" / "SEQUENCE OF"
     * - Each new item is of type_inner
     * - The user can add multiple items
     ***************************************************/
    function createSetOfContainer(typeInner, container, path) {
        const wrapper = document.createElement("div");
        wrapper.className = "nested set-of-wrapper";

        const itemsContainer = document.createElement("div");
        itemsContainer.className = "set-of-items";

        // An "Add item" button with bold + symbol
        const addBtn = document.createElement("button");
        addBtn.type = "button";
        addBtn.textContent = "🞧"; // Add item
        addBtn.className = "btn-add";

        addBtn.addEventListener("click", () => {
            // For each new item, we create a nested form or field for typeInner
            const itemIndex = itemsContainer.children.length; // 0-based
            const newItemPath = [...path, String(itemIndex)];

            const itemFieldset = document.createElement("fieldset");
            itemFieldset.className = "inline-elements";
            const legend = document.createElement("legend");
            legend.textContent = `Item [${itemIndex}]`;
            itemFieldset.appendChild(legend);

            // A "Remove this item" button
            const removeBtn = document.createElement("button");
            removeBtn.type = "button";
            removeBtn.textContent = "✖"; // ❌ Remove this item
            removeBtn.className = "btn-remove";
            removeBtn.addEventListener("click", () => {
                itemsContainer.removeChild(itemFieldset);
                refreshOutput();
            });
            itemFieldset.appendChild(removeBtn);
            
            const typeInner_group = identify_dict_list(jsonContent, typeInner);
            let typeInner_table;
            if (typeInner_group) {
                typeInner_table = jsonContent[typeInner_group][typeInner].table;
            }

            // Now, render typeInner (could be SEQUENCE, BIT STRING, etc.)
            if (typeInner_group === "SEQUENCE") {
                const nestedDiv = document.createElement("div");
                nestedDiv.className = "nested";
                createFormForSequence(typeInner, nestedDiv, newItemPath);
                itemFieldset.appendChild(nestedDiv);

            } else if (typeInner_group === "CHOICE") {
                createChoiceField(typeInner, "SET OF item", itemFieldset, newItemPath);

            } else if (typeInner_group === "INTEGER") {
                createIntegerField(typeInner, "SET OF item", itemFieldset, newItemPath, false, typeInner_table[0].Size);

            } else if (typeInner_group === "ENUMERATED") {
                createIntegerField(typeInner, "SET OF item", itemFieldset, newItemPath, true, typeInner_table.Length);

            } else if (typeInner_group === "BIT STRING") {
                createFormForBitString(typeInner, itemFieldset, newItemPath);

            } else {
                // Just a primitive fallback
                createPrimitiveField(typeInner, "SET OF item", itemFieldset, newItemPath);
            }

            itemsContainer.appendChild(itemFieldset);
            refreshOutput();
        });

        wrapper.appendChild(addBtn);
        wrapper.appendChild(itemsContainer);
        container.appendChild(wrapper);
    }


    /***************************************************
     * Create a CHOICE field
     * - Renders a dropdown for each Tag in that CHOICE
     * - Then, when user picks one, we show the sub-structure
     * @param {string} choiceName - name of the json entry
     * @param {string} description - description of the field
     * @param {object} container - parent container for the field
     * @param {Array} path - path to the field in the JSON object
     ***************************************************/
    function createChoiceField(choiceName, description, container, path) {
        const choiceDef = jsonContent["CHOICE"][choiceName];
        if (!choiceDef || !choiceDef.table) {
            const p = document.createElement("p");
            p.textContent = `CHOICE ${choiceName} has no table.`;
            container.appendChild(p);
            return;
        }

        // A wrapper
        const div = document.createElement("div");
        div.className = "nested choice-wrapper";

        const label = document.createElement("label");
        const description_parts = description.split(":");
        label.textContent = `${description_parts[description_parts.length-1].trim()}`; // (CHOICE)
        div.appendChild(label);

        const select = document.createElement("select");
        select.dataset.path = path.join(".");
        // We store user’s selection in refreshOutput as well
        // but also we show sub-fields as soon as they choose.

        // row 0 is header, skip
        const choiceRows = choiceDef.table.slice(1);

        // Add a "please select" option
        const defaultOpt = document.createElement("option");
        defaultOpt.value = "";
        defaultOpt.textContent = "Please select a CHOICE option...";
        select.appendChild(defaultOpt);

        choiceRows.forEach(row => {
            const opt = document.createElement("option");
            opt.value = row.Tag; // e.g. "A0"
            opt.textContent = `${row.Tag} - ${row.type_inner}`;
            select.appendChild(opt);
        });

        // A container for sub-fields
        const subFieldsContainer = document.createElement("div");
        subFieldsContainer.className = "nested choice-subfields";

        select.addEventListener("change", () => {
            // Clear previous sub-fields
            subFieldsContainer.innerHTML = "";
            const tagSelected = select.value;
            if (!tagSelected) {
                refreshOutput();
                return;
            }

            const row = choiceRows.find(r => r.Tag === tagSelected);
            if (!row) {
                refreshOutput();
                return;
            }

            const newPath = [...path, tagSelected];

            // If row.type_inner is a SEQUENCE / BIT STRING / ...
            if (row.type_inner && jsonContent.SEQUENCE[row.type_inner]) {
                createFormForSequence(row.type_inner, subFieldsContainer, newPath);
            } else if (row.type_inner && jsonContent["BIT STRING"][row.type_inner]) {
                createFormForBitString(row.type_inner, subFieldsContainer, newPath);
            } else if (row.type_inner && (jsonContent["OCTET STRING"][row.type_inner] || row.type_inner === "OCTET STRING")) {
                createOctetStringField(row.type_inner, `CHOICE subfield`, subFieldsContainer, newPath, row.Size);
            } else if (row.type_inner && jsonContent["ENUMERATED"][row.type_inner]) {
                createIntegerField(row.type_inner, `CHOICE subfield`, subFieldsContainer, newPath, true, row.Length);
            } else if (row.type_inner && jsonContent["CHOICE"][row.type_inner]) {
                createChoiceField(row.type_inner, `CHOICE subfield`, subFieldsContainer, newPath);
            } else if (row.type_inner && jsonContent["INTEGER"][row.type_inner]) {
                createIntegerField(row.type_inner, `CHOICE subfield`, subFieldsContainer, newPath, false, row.Length);
            } else if (row.type_inner === 'NULL') {
                createNullField(`CHOICE subfield`, subFieldsContainer, newPath);
            } else {
                // Otherwise, primitive fallback
                createPrimitiveField(row.type_inner, `CHOICE subfield`, subFieldsContainer, newPath);
            }

            refreshOutput();
        });

        select.addEventListener("input", refreshOutput);

        div.appendChild(select);
        div.appendChild(subFieldsContainer);
        container.appendChild(div);
        refreshOutput();
    }


    /***************************************************
     * Create a dropdown for ENUMERATED or input for INTEGER definitions
     * - If isEnumerated is true, we read from jsonContent.ENUMERATED[typeName].table
     * - Otherwise from jsonContent.INTEGER[typeName].table
     * @param {string} typeName - name of the json entry
     * @param {string} description - description of the field
     * @param {object} container - parent container for the field
     * @param {Array} path - path to the field in the JSON object
     * @param {boolean} isEnumerated - true if ENUMERATED, false if INTEGER
     * @param {string} length - possible number of bytes for the value
     ***************************************************/
    function createIntegerField(typeName, description, container, path, isEnumerated, length) {
        const intDef = isEnumerated
            ? jsonContent["ENUMERATED"][typeName]
            : jsonContent["INTEGER"][typeName];

        if ((!intDef || !intDef.table) && isEnumerated) {
            const p = document.createElement("p");
            p.textContent = `${isEnumerated ? "ENUMERATED" : "INTEGER"} ${typeName} has no data.`;
            container.appendChild(p);
            return;
        }

        // const label = document.createElement("label");
        // label.textContent = description;
        // container.appendChild(label);

        if (isEnumerated) {
            const select = document.createElement("select");
            select.dataset.path = path.join(".");

            // "Please select" option
            const defaultOpt = document.createElement("option");
            defaultOpt.value = "";
            defaultOpt.textContent = "Please select...";
            select.appendChild(defaultOpt);

            intDef.table.forEach(entry => {
                const opt = document.createElement("option");
                opt.value = entry.Name; // store the numeric or string Value
                opt.textContent = `${entry.Name} (${entry.Value})`;
                select.appendChild(opt);
            });

            select.addEventListener("change", refreshOutput);
            container.appendChild(select);
        } else {
            const min_max_length = extractMinMaxValue(length);

            const intInput = document.createElement("input");
            intInput.type = "number";
            intInput.min = "0";
            intInput.dataset.path = path.join(".");
            intInput.placeholder = `Input for ${description.trim()} [0-9]`;

            intInput.addEventListener('keydown', restrictKeyInputInteger);
            intInput.addEventListener('input', restrictOtherInputInteger);

            intInput.addEventListener('input', () => {
                // define max value for input
                if (parseInt(intInput.value) > Number.MAX_SAFE_INTEGER) {
                    intInput.value = Number.MAX_SAFE_INTEGER.toString();
                }
                // red coloring for invalid input
                const byteLength = hhex(intInput.value).length / 2;
                if (byteLength > min_max_length[1] || byteLength < min_max_length[0]) {
                    intInput.classList.add('error');
                } else {
                    intInput.classList.remove('error');
                }
            });

            intInput.addEventListener("input", refreshOutput);
            container.appendChild(intInput);
        }
        refreshOutput();
    }

    /**
     * Extracts the lowest and largest value from a given string.
     * @param {string} valueStr - The input string (e.g., "0..65536", "5..n", "20").
     * @returns {Array} The lowest and largest value for comparison: [lowest,largest]
     */
    function extractMinMaxValue(valueStr) {
        // Check if the string contains a range
        if (valueStr.includes("..")) {
            const parts = valueStr.split("..");
            const minValue = parseInt(parts[0], 10);
            const maxValue = parts[1] === 'n' ? Number.MAX_SAFE_INTEGER : parseInt(parts[1], 10);
            return [minValue, maxValue];
        } else {
            // Single value
            const value = parseInt(valueStr, 10);
            return [value, value]
        }
    }

    /**
     * OCTET STRING as a textarea (large input) or input (small input)
     * @param {string} typeName - type name of the OCTET STRING
     * @param {string} description - description of the field
     * @param {object} container - parent container for the field
     * @param {Array} path - path to the field in the JSON object
     * @param {string} length - possible number of bytes for the value
     */
    function createOctetStringField(typeName, description, container, path, length) {
        let formElement;

        const min_max_length = extractMinMaxValue(length);

        if (min_max_length[1] > 32) {
            // large textarea (multiline)
            formElement = document.createElement("textarea");
        } else {
            // small input (single line)
            formElement = document.createElement("input");
            formElement.type = "text";
        }

        formElement.addEventListener('keydown', restrictKeyInputOctet);
        formElement.addEventListener('input', restrictOtherInputOctet);

        formElement.addEventListener('input', function() {
            // only uppercase for output
            formElement.value = formElement.value.toUpperCase();
            // only full bytes are accepted
            if (formElement.value.length > 0 && formElement.value[0] == '0') {
                formElement.value = formElement.value.slice(1);
            }
            if (formElement.value.length % 2 !== 0) {
                formElement.value = '0' + formElement.value;
            }
            // byte length is half of the value string length
            const byteLength = formElement.value.length / 2;
    
            if (byteLength > min_max_length[1] || byteLength < min_max_length[0]) {
                formElement.classList.add('error');
                // formElement.classList.remove('valid');
            } else {
                // formElement.classList.add('valid');
                formElement.classList.remove('error');
            }
        });

        formElement.dataset.path = path.join(".");
        formElement.placeholder = `Input for ${description.trim()} [0-9a-fA-F]`;
        formElement.addEventListener("input", refreshOutput);

        container.appendChild(formElement);
    }

    /**
     * Create checkbox if NULL should be displayed in output
     * @param {string} labelText - The label text for the NULL field
     * @param {object} container - The parent container for the NULL field
     * @param {Array} path - The path to the field in the JSON object
     */
    function createNullField(labelText, container, path) {
        const label = document.createElement("label");
        label.style.display = "inline-flex";
        label.style.alignItems = "center";
        label.style.marginRight = "10px";

        const checkbox = document.createElement("input");
        checkbox.type = "checkbox";
        checkbox.style.marginRight = "5px";
        checkbox.style.width = "20px";
        checkbox.dataset.path = path.join(".");
        checkbox.addEventListener("change", refreshOutput);
        
        label.appendChild(checkbox);
        label.appendChild(document.createTextNode(" Display NULL Type ")); // ` ${labelText} `

        container.appendChild(label);
    }

    /***************************************************
     * BOOLEAN as a dropdown (true / false)
     * @param {string} typeInner - type name of the BOOLEAN
     * @param {string} description - description of the field
     * @param {object} container - parent container for the field
     * @param {Array} path - path to the field in the JSON object
     ***************************************************/
    function createPrimitiveField(typeInner, description, container, path) {
        let formElement;

        // If the user wants BOOLEANS as a dropdown:
        if (typeInner === "BOOLEAN") {
            formElement = document.createElement("select");
            // We add 3 states: empty (not chosen), "true", "false"
            const optEmpty = document.createElement("option");
            optEmpty.value = "";
            optEmpty.textContent = "Please select true or false...";
            formElement.appendChild(optEmpty);

            const optTrue = document.createElement("option");
            optTrue.value = "true";
            optTrue.textContent = "true";
            formElement.appendChild(optTrue);

            const optFalse = document.createElement("option");
            optFalse.value = "false";
            optFalse.textContent = "false";
            formElement.appendChild(optFalse);

        } else if (typeInner === "INTEGER") {
            // Basic fallback for an integer if not enumerated:
            formElement = document.createElement("input");
            formElement.type = "number";

        // } else if (typeInner === "OCTET STRING") {
        //     formElement = document.createElement("textarea");
        //     formElement.addEventListener('keydown', restrictKeyInput);
        //     formElement.addEventListener('input', restrictOtherInput);

        } else {
            // Generic fallback: text
            formElement = document.createElement("input");
            formElement.type = "text";
        }

        formElement.dataset.path = path.join(".");
        formElement.placeholder = `Input for ${description}`;
        formElement.addEventListener("input", refreshOutput);

        container.appendChild(formElement);
    }


    /***************************************************
     * Create checkboxes for a BIT STRING definition
     * @param {string} bitStringName - The name of the BIT STRING
     * @param {object} container - The parent container for the checkboxes
     * @param {Array} path - The path to the field in the JSON object
     ***************************************************/
    function createFormForBitString(bitStringName, container, path) {
        const bsDef = jsonContent["BIT STRING"][bitStringName];
        if (!bsDef || !bsDef.table || bsDef.table.length < 2) {
            const p = document.createElement("p");
            p.textContent = `BIT STRING ${bitStringName} has no data.`;
            container.appendChild(p);
            return;
        }

        // row[0] is header
        let rows = bsDef.table.slice(1);

        // add EMPTY row in front
        let emptyEntry = [...rows[0]];
        for (let i = 0; i <= emptyEntry.length - 1; i++) {
            if (i === emptyEntry.length - 1) {
                emptyEntry[i] = '"EMPTY": Use default value, all bits are zero';
            } else {
                if (emptyEntry[i] != '0' && emptyEntry[i] != 'x') emptyEntry[i] = "0";
            }
        }
        rows.unshift(emptyEntry);

        rows.forEach((row, rowIndex) => {
            const description = row[row.length - 1] || `Bit ${rowIndex}`;

            const label = document.createElement("label");
            label.style.display = "inline-flex";
            label.style.alignItems = "center";
            label.style.marginRight = "10px";

            const checkbox = document.createElement("input");
            if (rowIndex === 0) {
                checkbox.type = "checkbox"; // radio did not work, has always value "on"
            } else {
                checkbox.type = "checkbox";
            }
            checkbox.style.marginRight = "5px";
            checkbox.style.width = "20px";

            let newPath;
            if (rowIndex === 0) {
                newPath = [...path, "empty"];
            } else {
                newPath = [...path, `bit${rowIndex - 1}`];
            }
            checkbox.dataset.path = newPath.join(".");

            checkbox.addEventListener("change", function() {
                const emptyCheckbox = container.querySelector(`input[data-path="${[...path, `empty`].join(".")}"]`);
                for (let i = 0; i < rows[rowIndex].length; i++) {
                    if (rows[rowIndex][i] === "0") {
                        for (let j = 0; j < rows.length; j++) {
                            if (rows[j][i] === "1") {
                                // uncheck all other checkboxes with opposite value
                                const otherCheckbox = container.querySelector(`input[data-path="${[...path, `bit${j - 1}`].join(".")}"]`);
                                otherCheckbox.checked = false;
                            }
                        }
                    }
                    if (rows[rowIndex][i] === "1") {
                        emptyCheckbox.checked = false;
                        for (let j = 1; j < rows.length; j++) {
                            if (rows[j][i] === "0") {
                                // uncheck all other checkboxes with opposite value
                                const otherCheckbox = container.querySelector(`input[data-path="${[...path, `bit${j - 1}`].join(".")}"]`);
                                otherCheckbox.checked = false;
                            }
                        }
                    }
                }
                if (emptyCheckbox.checked) {
                    // grey out all other checkboxes
                    emptyCheckbox.parentElement.classList.remove('disabled-label');
                    for (let i = 1; i < rows.length; i++) {
                        const otherCheckbox = container.querySelector(`input[data-path="${[...path, `bit${i - 1}`].join(".")}"]`);
                        otherCheckbox.parentElement.classList.add('disabled-label');
                    }
                } else {
                    // grey out "EMPTY" checkbox
                    emptyCheckbox.parentElement.classList.add('disabled-label');
                    for (let i = 1; i < rows.length; i++) {
                        const otherCheckbox = container.querySelector(`input[data-path="${[...path, `bit${i - 1}`].join(".")}"]`);
                        otherCheckbox.parentElement.classList.remove('disabled-label');
                    }
                }
            });
            checkbox.addEventListener("change", refreshOutput);

            label.appendChild(checkbox);
            label.appendChild(document.createTextNode(` ${description.split(":")[0].replaceAll('"', '')}  `));

            container.appendChild(label);
        });

        refreshOutput();
    }


    /***************************************************
     * Dynamically read all values and build an object
     * - this function is called after every input
     * - it reads all input fields and builds an object
     * - target is the outputPre element
     ***************************************************/
    function refreshOutput() {
        if (!currentCommandTag) {
            outputPre.textContent = "No inputs yet...";
            return;
        }

        // identify all input fields in document
        // filter for choice-wrapper, to create nested objects
        const allFields = [...parameterForm.querySelectorAll(
            "input, textarea, select"
        )].filter(elm => !elm.parentNode.classList.contains("choice-wrapper"));
        
        const paramObj = {};

        allFields.forEach((field) => {
            const pathStr = field.dataset.path;
            if (!pathStr) return;
            const pathArr = pathStr.split(".");

            let value;
            // If it's the dropdown for boolean, we store true/false/"" accordingly
            if (field.tagName === "SELECT") {
                // for enumerated, choice, boolean, we store the .value (string)
                // user might choose "" => no selection
                if (field.value === "true") {
                    value = true;
                } else if (field.value === "false") {
                    value = false;
                } else {
                    value = field.value;
                }
            } else if (field.type === "checkbox") {
                value = field.checked;
            } else {
                value = field.value;
            }

            setValueAtPath(paramObj, pathArr, value);
        });
        
        // identify Admin- or Client-Tag
        let currentChoiceTag = '';
        if (currentChoice.includes('Admin')) {
            currentChoiceTag = 'A1';
            console.log('Admin command: ' + currentChoiceTag);
        } else if (currentChoice.includes('Client')) {
            currentChoiceTag = 'A2';
            console.log('Client command: ' + currentChoiceTag);
        } else {
            throw new Error('Unknown command type: ' + currentChoice);
        }

        // The user wants top level to be the selected Tag
        const finalOutput = {
            [currentCommandTag]: paramObj
        };

        // calculate inner tlv output and length
        let tlvOutput = handle_output_json(jsonContent, currentChoice, finalOutput, true);
        let tlvLength = length_octets_hex(tlvOutput.length / 2);

        // add main sequence inner command tag and length
        tlvOutput = 'A0' + tlvLength + tlvOutput;
        tlvLength = length_octets_hex(tlvOutput.length / 2);

        const jsonOutput = '{\n  "' + currentChoiceTag + '": {\n    "A0": ' + asn1Stringify(finalOutput, 2, 4) + '\n  }\n}';
        
        // add main sequence outer command tag and length
        outputPre.textContent = currentChoiceTag + tlvLength + tlvOutput;
        outputPre.textContent += '\n\n' + jsonOutput;
    }


    /***************************************************
     * Helper to place a value in a nested object
     * @param {object} obj - The object to modify
     * @param {Array} pathArr - The path to the value
     * @param {any} value - The value to set
     ***************************************************/
    function setValueAtPath(obj, pathArr, value) {
        if (pathArr.length === 0) return;
        const [head, ...tail] = pathArr;
        if (!obj[head]) obj[head] = {};

        if (tail.length === 0) {
            obj[head] = value;
        } else {
            setValueAtPath(obj[head], tail, value);
        }
    }

    /**
     * copies the given text to clipboard and shows an alert message
     * @param {string} textToCopy - the text to copy to clipboard
     * @param {string} message - the message to show after copying
     */
    function copyToClipboard(textToCopy, message) {
        // create temporary textarea
        const tempTextArea = document.createElement('textarea');
        tempTextArea.value = textToCopy;
        document.body.appendChild(tempTextArea);
        // select text of textarea
        tempTextArea.select();
        tempTextArea.setSelectionRange(0, 99999); // Für mobile Geräte
        // copy to clipboard
        document.execCommand('copy');
        // remove textarea
        document.body.removeChild(tempTextArea);
        // show alert message as feedback
        alert(message);
    }

    /**
     * event listener to copy TLV output to clipboard = first line
     */
    document.getElementById('copyButtonTLV').addEventListener('click', function() {
        const outputPre = document.getElementById('outputPre');
        const textToCopy = outputPre.textContent.split('\n')[0];
        copyToClipboard(textToCopy, 'TLV copied to clipboard');
    });

    /**
     * event listener to copy JSON output to clipboard = content after first line
     */ 
    document.getElementById('copyButtonJSON').addEventListener('click', function() {
        const outputPre = document.getElementById('outputPre');
        const textToCopy = outputPre.textContent.split('\n').slice(1).join('\n').trim();
        copyToClipboard(textToCopy, 'JSON copied to clipboard');
    });
});
